import networkx as nx
import matplotlib.pyplot as plt
import math
import operator
from numpy import *
import numpy as np
import scipy.io as sio
from scipy.io import mmread
# from sio import mmread
from functools import partial
from networkx.generators.community import LFR_benchmark_graph


# 抽取txt中的数据
def read_txt(data):
    g = nx.read_weighted_edgelist(data)
    print(g.edges())
    isolated_nodes = [node for node in G.nodes() if G.degree(node) == 0]
    for node in isolated_nodes:
        g.remove_node(node)
    return g

######################################################
def gDegree(G):
    """
    将G.degree()的返回值变为字典
    """
    node_degrees_dict = {}
    for i in G.degree():
        node_degrees_dict[i[0]] = i[1]
    # isolated_nodes = [node for node in G.nodes() if G.degree(node) == 0]
    # for node in isolated_nodes:
    #     G.remove_node(node)
    # print('node_degrees_dict=',node_degrees_dict)
    return node_degrees_dict.copy()#返回一个与 node_degrees_dict相同的字典，并且与原字典独立，不会影响原始字典中的值。
#############################################################################
def min_degree(G):
    '''计算图中节点的最小度'''
    degrees = [d for n, d in G.degree()]
    min_node_degree = min(degrees)
    return min_node_degree
#########################################
def get_Node_neighbor(G):###计算每个节点相邻的节点的k值
    """
    计算节点的重要性指数
    """
    # sum = sumD(G)
    I = {}
    G_degrees = gDegree(G)
    for k, v in G_degrees.items():
        I[k] = {}
        Neighbor = []
        for i in G.neighbors(k):### 返回k节点的所有邻居节点
            Neighbor.append(G_degrees[i])
            I[k] = Neighbor
    return I.copy()

def get_Node_neighbor_v(G):###计算每个节点的相邻节点的度值
    """
    计算节点的重要性指数
    """
    # sum = sumD(G)
    I = {}
    G_degrees = gDegree(G)
    for k, v in G_degrees.items():
        I[k] = {}
        Neighbor = []

        for i in G.neighbors(k):### 返回k节点的所有邻居节点
            Neighbor.append(G_degrees[i])
            I[k] = Neighbor
        # for i in G.neighbors(k):### 返回k节点的所有邻居节点
        #     sum += I[i] * math.log(I[i])
        # print("node {}: value:{}".format(k, I[k]))
    return I.copy()
def get_Node_ks_v_k(G):###计算每个节点的 kshell 值
    """
    计算节点的重要性指数
    """
    # sum = sumD(G)
    # I = {}
    ks_v_k = {}
    G_degrees = gDegree(G)
    G_ks =kshell(G)
    for k, v in G_ks.items():
        # I[k] = {}
        # Neighbor = []
        for i in v:
            # ks_v_k[v] = {}
            ks_v_k[i] = k
            # print("node {}: kshell:{}".format(i, ks_v_k[i]))
    return ks_v_k.copy()
#############################
# def get_Node_ks_layer(G):###计算每个节点的相邻节点的 kshell 值
#     """
#     计算节点的重要性指数
#     """
#     # sum = sumD(G)
#     # I = {}
#     ks_v_k = {}
#     G_degrees = gDegree(G)
#     G_ks =kshell(G)
#     for k, v in G_ks.items():
#         # I[k] = {}
#         # Neighbor = []
#         N = 0
#         for i in v:
#             # ks_v_k[v] = {}
#             N++
#             ks_v_k[i] = k
#         print("node {}: layer:{}".format(i, ks_v_k[i]))
#     return ks_v_k
############################
def get_Node_neighbor_ks(G):###计算每个节点的相邻节点的kshell值
    """
    计算节点的重要性指数
    """
    # sum = sumD(G)
    # I = {}
    node_neighbor_ks_list = {}
    G_degrees = gDegree(G)
    # G_ks =kshell(G)
    N_ks = get_Node_ks_v_k(G)
    print('N_ks =',N_ks)
    for node, ks in N_ks.items():
        node_neighbor_ks_list[node] = {}
        Neighbor_kshell = []
        for i in G.neighbors(node):
            Neighbor_kshell.append(N_ks[i])
        # print("node {}: Neighbor_ks:{}".format(node, Neighbor_kshell))
        node_neighbor_ks_list[node] = Neighbor_kshell
    return node_neighbor_ks_list.copy()
#######################################################################
def get_Node_neighbor_ks_max(G):###计算每个节点的相邻节点的kshell值
    """
    计算节点的重要性指数
    """
    # sum = sumD(G)
    # I = {}
    node_neighbor_ks_list_max = {}
    G_degrees = gDegree(G)
    # G_ks =kshell(G)
    N_ks = get_Node_ks_v_k(G)
    # print('N_ks =',N_ks)
    for node, ks in N_ks.items():
        node_neighbor_ks_list_max[node] = {}
        Neighbor_kshell = []
        for i in G.neighbors(node):
            Neighbor_kshell.append(N_ks[i])
        # print("node {}: Neighbor_ks:{}".format(node, max(Neighbor_kshell)))
        node_neighbor_ks_list_max[node] = max(Neighbor_kshell)
    return node_neighbor_ks_list_max.copy()
##########################################################
def get_Node_neighbor_degree_max(G):###计算每个节点的相邻节点的kshell值
    """
    计算节点的重要性指数
    """
    # sum = sumD(G)
    # I = {}
    node_neighbor_ks_list_max = {}
    G_degrees = gDegree(G)
    Node_max_degree = {}
    for k,v in G_degrees.items():
        Neighbor_node_degree_list = []
        Node_max_degree[k] = {}
        for i in G.neighbors(k):
            Neighbor_node_degree_list.append(G_degrees[i])
        Neighbor_node_degree_list.append(1)
        Node_max_degree[k] = max(Neighbor_node_degree_list)
    return Node_max_degree.copy()
#####################################################################
def get_Node_neighbor_v_max(G):###计算每个节点的相邻节点的度值
    """
    计算节点的重要性指数
    """
    # sum = sumD(G)
    I_max = {}
    G_degrees = gDegree(G)
    for k, v in G_degrees.items():
        I_max[k] = {}
        Neighbor = []
        for i in G.neighbors(k):### 返回k节点的所有邻居节点
            Neighbor.append(G_degrees[i])
            I_max[k] = max(Neighbor)
        # for i in G.neighbors(k):### 返回k节点的所有邻居节点
        #     sum += I[i] * math.log(I[i])
        # print("node {}: value_max:{}".format(k, I_max[k]))
    return I_max.copy()
#############################################################
#############################################################
#############################################################
def Kshell_plus_1(G):
    '''计算KPD的值'''
    pass
    G_degrees = gDegree(G)#计算每个节点的度值
    G_Kshell = kshell2(G)#计算不同kshell下的节点，也就是 计算 kshell 的过程
    G_node_Kshell = get_Node_ks_v_k(G)#计算每个节点  对应的kshell值
    G_kshell_layer = kshell_layer(G)#计算每个节点所在的  kshell的  layer值
    G_get_Node_neighbor_ks_max = get_Node_neighbor_ks_max(G1)#计算节点邻居的最大kshell值
    G_max_layer = max_layer(G)#计算出各节点的  最大layer值
    G_max_neighbor_degree = get_Node_neighbor_degree_max(G)
    KSL_Node = {}
    KPD_Node = {}
    for k, v in G_kshell_layer.items():
        KSL_Node[k] = v/(1+G_max_layer[k])*max(1,G_get_Node_neighbor_ks_max[k]-G_node_Kshell[k])
    # print('KSL_Node=',KSL_Node)
    for k, v in G_node_Kshell.items():
        # KPD_Node[k] = v + KSL_Node[k]*(1+G_degrees[k]/(G_max_neighbor_degree[k]+1))
        # KPD_Node[k] = v + KSL_Node[k] + G_degrees[k] / (G_max_neighbor_degree[k] + 1) * G_max_neighbor_degree[k]
        # KPD_Node[k] = v + KSL_Node[k] + G_degrees[k] / (G_max_neighbor_degree[k] + 1) * KSL_Node[k]
        KPD_Node[k] = v + KSL_Node[k] * G_degrees[k] / (G_max_neighbor_degree[k] + G_degrees[k] + 1)
    return KPD_Node.copy()
##############################################################

def KPD_Value(G):
    '''计算KPD的值'''
    pass
    G_degrees = gDegree(G)#计算每个节点的度值
    G_Kshell = kshell2(G)#计算不同kshell下的节点，也就是 计算 kshell 的过程
    G_node_Kshell = get_Node_ks_v_k(G)#计算每个节点  对应的kshell值
    G_kshell_layer = kshell_layer(G)#计算每个节点所在的  kshell的  layer值
    G_get_Node_neighbor_ks_max = get_Node_neighbor_ks_max(G1)#计算节点邻居的最大kshell值
    G_max_layer = max_layer(G)#计算出各节点的  最大layer值
    G_max_neighbor_degree = get_Node_neighbor_degree_max(G)
    KSL_Node = {}
    KPD_Node = {}
    for k, v in G_kshell_layer.items():
        KSL_Node[k] = v/(1+G_max_layer[k])*max(1,G_get_Node_neighbor_ks_max[k]-G_node_Kshell[k])
    # print('KSL_Node=',KSL_Node)
    for k, v in G_node_Kshell.items():
        # KPD_Node[k] = v + KSL_Node[k]*(1+G_degrees[k]/(G_max_neighbor_degree[k]+1))
        # KPD_Node[k] = v + KSL_Node[k] + G_degrees[k] / (G_max_neighbor_degree[k] + 1) * G_max_neighbor_degree[k]
        KPD_Node[k] = G_degrees[k] + v + KSL_Node[k]*(G_degrees[k]/(G_max_neighbor_degree[k]+1))######!!!!!!!!!!!!!!!!震惊！！！这个方法居然挺好
        # KPD_Node[k] = v + KSL_Node[k] + G_degrees[k] / (G_max_neighbor_degree[k] + 1) * KSL_Node[k]
        # KPD_Node[k] = v + KSL_Node[k] * G_degrees[k] / (G_max_neighbor_degree[k] + G_degrees[k] + 1)
    return KPD_Node.copy()
def Ks_add_D_Value(G):
    '''计算KPD的值'''
    pass
    G_degrees = gDegree(G)#计算每个节点的度值
    G_Kshell = kshell2(G)#计算不同kshell下的节点，也就是 计算 kshell 的过程
    G_node_Kshell = get_Node_ks_v_k(G)#计算每个节点  对应的kshell值
    G_kshell_layer = kshell_layer(G)#计算每个节点所在的  kshell的  layer值
    G_get_Node_neighbor_ks_max = get_Node_neighbor_ks_max(G1)#计算节点邻居的最大kshell值
    G_max_layer = max_layer(G)#计算出各节点的  最大layer值
    G_max_neighbor_degree = get_Node_neighbor_degree_max(G)
    KSL_Node = {}
    KPD_Node = {}
    for k, v in G_kshell_layer.items():
        KSL_Node[k] = v/(1+G_max_layer[k])*max(1,G_get_Node_neighbor_ks_max[k]-G_node_Kshell[k])
    # print('KSL_Node=',KSL_Node)
    for k, v in G_node_Kshell.items():
        # KPD_Node[k] = v + KSL_Node[k]*(1+G_degrees[k]/(G_max_neighbor_degree[k]+1))
        # KPD_Node[k] = v + KSL_Node[k] + G_degrees[k] / (G_max_neighbor_degree[k] + 1) * G_max_neighbor_degree[k]
        KPD_Node[k] = G_degrees[k] + v + KSL_Node[k]*(G_degrees[k]/(G_max_neighbor_degree[k]+1))######!!!!!!!!!!!!!!!!震惊！！！这个方法居然挺好
        # KPD_Node[k] = v + KSL_Node[k] + G_degrees[k] / (G_max_neighbor_degree[k] + 1) * KSL_Node[k]
        # KPD_Node[k] = v + KSL_Node[k] * G_degrees[k] / (G_max_neighbor_degree[k] + G_degrees[k] + 1)
    return KPD_Node.copy()
####################################################
def max_layer(G):
    '''计算同kshell下的layer的最大值'''
    G_Kshell = kshell2(G)  # 计算不同kshell下的节点，也就是 计算 kshell 的过程
    G_node_Kshell = get_Node_ks_v_k(G)  # 计算每个节点的kshell值
    G_kshell_layer = kshell_layer(G)  # 计算每个节点所在的kshell的layer
    ############################
    kshell_layer_max={}
    for k,v in G_Kshell.items():
        node_layer_list = []
        for node in v:
            node_layer_list.append(G_kshell_layer[node])
        kshell_layer_max[k] = max(node_layer_list)
        # print('node_layer_list=',node_layer_list,'max_layer=',kshell_layer_max[k])
    layer_max = {}
    for k2,v2 in G_node_Kshell.items():
        layer_max[k2] = kshell_layer_max[v2]
    return layer_max.copy()
####################################################################################
def Get_Move_Methods(G):
    ###
    nums = len(G.nodes())
    largest_cc = max(nx.connected_components(G), key=len)
    # print('最大连通子图大小：=',largest_cc,'图大小',nums)
    print('图G的基本信息：', G)
    print('最大连通子图大小：=', len(largest_cc), '图大小', len(G))
    initial_size = len(largest_cc) / len(G)
    relative_sizes = {}#np.zeros(nums)
    relative_sizes[0] = initial_size
    G_removed = G.copy()
    for i in range(1,nums-1):
        # list_max_to_min = dict(G_removed.degree())# 获取节点度值排序后的列表
        # list_max_to_min =Get_KPDN(G_removed)
        list_max_to_min = KPD_Value(G_removed)
        # list_max_to_min = Get_DWT(G_removed)

        sorted_degrees = sorted(list_max_to_min.items(), key=lambda x: x[1], reverse=True)
        # sorted_degrees = sorted(list_max_to_min.items(), key=lambda x: x[1], reverse=False)
        # 计算要移除的节点列表
        removed_nodes = [x[0] for x in sorted_degrees[:1]]
        # 移除节点并计算剩余网络的巨连通分支大小
        G_removed.remove_nodes_from(removed_nodes)
        if len(G_removed) == 0:
            break
        largest_cc_removed = max(nx.connected_components(G_removed), key=len)
        relative_sizes[i/nums] = len(largest_cc_removed) / nums
        if i%100 == 0:
            print('当前进度',i/nums*100,'%,下降率为：',relative_sizes[i/nums])
    return relative_sizes
####################################################################################
def Get_Move_Methods_DC(G):
    ###
    nums = len(G.nodes())
    largest_cc = max(nx.connected_components(G), key=len)
    # print('最大连通子图大小：=',largest_cc,'图大小',nums)
    print('最大连通子图大小：=', len(largest_cc), '图大小', len(G))
    initial_size = len(largest_cc) / len(G)
    relative_sizes = {}#np.zeros(nums)
    relative_sizes[0] = initial_size
    G_removed = G.copy()
    for i in range(1,nums-1):
        list_max_to_min = dict(G_removed.degree())# 获取节点度值排序后的列表
        # list_max_to_min =Get_KPDN(G_removed)
        # list_max_to_min = KPD_Value(G_removed)
        # list_max_to_min = Get_DWT(G_removed)

        sorted_degrees = sorted(list_max_to_min.items(), key=lambda x: x[1], reverse=True)
        # sorted_degrees = sorted(list_max_to_min.items(), key=lambda x: x[1], reverse=False)
        # 计算要移除的节点列表
        removed_nodes = [x[0] for x in sorted_degrees[:1]]
        # 移除节点并计算剩余网络的巨连通分支大小
        G_removed.remove_nodes_from(removed_nodes)
        if len(G_removed) == 0:
            break
        largest_cc_removed = max(nx.connected_components(G_removed), key=len)
        relative_sizes[i/nums] = len(largest_cc_removed) / nums
        if i%(0.01*nums+1) == 0:
            print('当前进度',i/nums*100,'%,下降率为：',relative_sizes[i/nums])
    return relative_sizes

####################################################################################
def Get_KPDN(G):###计算每个节点的相邻节点的度值
    """
    计算节点的重要性指数
    """
    ######### 假设这里已经算出来了 ##########
    G_KPD_Value = KPD_Value(G)
    KPDN = {}
    G_degrees = gDegree(G)
    Set_A = []
    Set_B = []
    for k, v in G_degrees.items():
        KPDN[k] = {}
        Neighbor = []
        E = 0
        Sum_KPD_E = 0
        Set_A = set(G.neighbors(k))
        for i in G.neighbors(k):### 返回k节点的所有邻居节点
            Set_B = set(G.neighbors(i))
            # E = len(Set_A & Set_B)/len(Set_A | Set_B)
            # E = (len(Set_A & Set_B)) / (len(Set_A | Set_B) + 1)
            # E = (len(Set_A & Set_B)) / (((v**2+G_degrees[i]**2)/2)**0.5)
            E = (len(Set_A & Set_B)) / ((v * G_degrees[i]) ** 0.5)
            # E = (len(Set_A & Set_B) + 1) / ((G_degrees[k]*G_degrees[i])**0.5)
            # E = (len(Set_A & Set_B) + 1) / ((G_KPD_Value[k] * G_KPD_Value[i]) ** 0.5)
            # Sum_KPD_E += E*G_KPD_Value[i]
            # Sum_KPD_E += ((E+1)/v)**2#E * G_KPD_Value[i]
            # Sum_KPD_E += (E + 1) ** 3  # E * G_KPD_Value[i]
            # Sum_KPD_E += ((E+1)/G_KPD_Value[i]) ** 2  # E * G_KPD_Value[i]!!!!!!!!!!!!!!!这个结果蛮好的！！！！！！！！！约等于DWT
            # Sum_KPD_E += ((E) / G_KPD_Value[i]) ** 2  # E * G_KPD_Value[i]!!!!!!!!!!!!!!!这个结果蛮好的！！！！！！！！！约等于DWT
            # Sum_KPD_E += ((E+1)/G_KPD_Value[i]) ** 2+((E) / G_KPD_Value[i]) ** 2  # E * G_KPD_Value[i]!!!!!!!!!!!!!!!这个结果蛮好的！！！！！！！！！约等于DWT
            # Sum_KPD_E += ((E + 1) / G_KPD_Value[i]) ** 2 + ((E + 1) / v) ** 2
            # Sum_KPD_E += ((E + 1) / G_KPD_Value[i]) ** 2 + (E / v) ** 2
            # Sum_KPD_E += ((E + 2) / v) ** 2  # + ((E + 1) / v) ** 2
            Sum_KPD_E += ((2*E + v) / G_KPD_Value[i]) ** 2  # + ((E + 1) / v) ** 2
            # Sum_KPD_E += ((E + 1) / G_KPD_Value[i]) ** 2
            # Sum_KPD_E += ((E + 1) / G_KPD_Value[i]) ** 2 + ((E) / G_KPD_Value[i]) ** 2 + (1 / G_KPD_Value[i]) ** 2  # E * G_KPD_Value[i]!!!!!!!!!!!!!!!这个结果蛮好的！！！！！！！！！约等于DWT
            # Sum_KPD_E += ((E + 3) / v) ** 2

            # Sum_KPD_E += ((E + 1)**2 / G_KPD_Value[i]) ** 2  #
        # KPDN[k] = G_KPD_Value[k] + Sum_KPD_E
        KPDN[k] = Sum_KPD_E
        # print("node {}: E:{}".format(k, KPDN[k]))
    return KPDN.copy()
def Get_DWT_3(G):  ###计算每个节点的相邻节点的度值
    """
    计算节点的重要性指数 to get DWT
    """
    ######### 假设这里已经算出来了 ##########
    G_KPD_Value = KPD_Value(G)
    KPDN = {}
    G_degrees = gDegree(G)
    Set_A = []
    Set_B = []
    for k, v in G_degrees.items():
        KPDN[k] = {}
        Neighbor = []
        E = 0
        Sum_KPD_E = 0
        Set_A = set(G.neighbors(k))
        for i in G.neighbors(k):### 返回k节点的所有邻居节点
            Set_B = set(G.neighbors(i))
            # E = len(Set_A & Set_B)/len(Set_A | Set_B)
            E = (len(Set_A & Set_B)) / (len(Set_A | Set_B) + 1)
            # Sum_KPD_E += E*G_KPD_Value[i]
            Sum_KPD_E += ((E+1)/v)**2#E * G_KPD_Value[i]
        # KPDN[k] = G_KPD_Value[k] + Sum_KPD_E
        KPDN[k] = Sum_KPD_E
        # print("node {}: E:{}".format(k, KPDN[k]))
    return KPDN.copy()
#############################################################################
# def get_N_N(G):
#     G_KPD_Value = KPD_Value(G)
#     DWT3 = {}
#     G_degrees = gDegree(G)
#     first_Set_A = []
#     second_Set_A = []
#     for k.v in G_degrees.items():
#         first_Set_A = set(G.neighbors(k))
#         for a in first_Set_A:
#             second_Set_A += set(G.neighbors(a))
#
def Get_DWT2(G):  ###计算每个节点的相邻节点的度值
    """
    计算节点的重要性指数
    """
    ######### 假设这里已经算出来了 ##########
    G_KPD_Value = KPD_Value(G)
    KPDN = {}
    G_degrees = gDegree(G)
    Set_A = []
    Set_B = []
    for k, v in G_degrees.items():
        KPDN[k] = {}
        Neighbor = []
        E = 0
        Sum_KPD_E = 0
        Set_A = set(G.neighbors(k))
        for i in G.neighbors(k):### 返回k节点的所有邻居节点
            Set_B = set(G.neighbors(i))
            # E = len(Set_A & Set_B)/len(Set_A | Set_B)
            E = (len(Set_A & Set_B)) / (len(Set_A | Set_B) + 1)
            # Sum_KPD_E += E*G_KPD_Value[i]
            # Sum_KPD_E += ((E + 1)**2 / v) ** 3  # E * G_KPD_Value[i]
            Sum_KPD_E += E**2#/v**2#E * G_KPD_Value[i]
        Sum_KPD_E = Sum_KPD_E/v**2 + 1 / v
        # KPDN[k] = G_KPD_Value[k] + Sum_KPD_E
        KPDN[k] = Sum_KPD_E
        # print("node {}: E:{}".format(k, KPDN[k]))
    return KPDN.copy()
#############################################################################

##############################################################
def Get_DWT(G):  ###计算每个节点的相邻节点的度值
    """
    计算节点的重要性指数
    """
    ######### 假设这里已经算出来了 ##########
    G_KPD_Value = KPD_Value(G)
    DWT_3 = {}
    DWT_3E ={}
    G_degrees = gDegree(G)
    Set_1st_A = []
    Set_2nd_A = []
    for k, v in G_degrees.items():
        # KPDN[k] = {}
        # Neighbor = []
        E = 0
        Sum_KPD_E = 0
        Set_2nd_A = set(G.neighbors(k))  # 找到1步邻居
        Set_1st_A = set(G.neighbors(k))  # 找到1步邻居
        for i in G.neighbors(k):  ### 返回k节点的所有邻居节点
            Set_2nd_A = set(G.neighbors(i))
        # Set_2nd_A = (Set_2nd_A | Set_1st_A)#-Set_1st_A# - (Set_2nd_A & Set_1st_A) ###避免只有一层邻居的情况
        DWT_3[k] = Set_2nd_A
        # DWT_3[k] = Set_1st_A
    for k, v in G_degrees.items():
        SET_A = set(G.neighbors(k))
        Sum_KPD_E = 0
        for i in G.neighbors(k):### 返回k节点的所有邻居节点
            SET_B = set(G.neighbors(i))
            # E = len(Set_A & Set_B)/len(Set_A | Set_B)
            # E = (len(DWT_3[k] & DWT_3[i])) / (len(DWT_3[k] | DWT_3[i]) + 1)
            # E = (len(DWT_3[k] & SET_B)) / (len(DWT_3[k] | SET_B) + 1)
            # E = (len(DWT_3[k] & SET_B)) / (len(DWT_3[k] | SET_B) + 1)
            # E = (len(SET_A & SET_B)) / (len(SET_A | SET_B) + 1)
            E = (len(SET_A & SET_B))/ ((v * G_degrees[i]) ** 0.5)
            # Sum_KPD_E += E*G_KPD_Value[i]
            Sum_KPD_E += ((E+1)/v)**2#E * G_KPD_Value[i]
        # KPDN[k] = G_KPD_Value[k] + Sum_KPD_E
        DWT_3E[k] = Sum_KPD_E
        # print("node {}: E:{}".format(k, KPDN[k]))
    # for k, v in G_degrees.items():
    #     KPDN[k] = {}
    #     Neighbor = []
    #     E = 0
    #     Sum_KPD_E = 0
    #     Set_A = set(G.neighbors(k))
    #     for i in G.neighbors(k):### 返回k节点的所有邻居节点
    #         Set_B = set(G.neighbors(i))
    #         # E = len(Set_A & Set_B)/len(Set_A | Set_B)
    #         E = (len(Set_A & Set_B)) / (len(Set_A | Set_B) + 1)
    #         # Sum_KPD_E += E*G_KPD_Value[i]
    #         Sum_KPD_E += ((E+1)/v)**2#E * G_KPD_Value[i]
    #     # KPDN[k] = G_KPD_Value[k] + Sum_KPD_E
    #     KPDN[k] = Sum_KPD_E
    return DWT_3E.copy()


def kshell(G):###kshell方法将节点按照kshell方法进行的排序
    graph = G.copy()
    importance_dict = {}
    level = min_degree(G)
    # level = min(graph.degree)
    # print('graph.degree=',graph.degree)#按照字典的形式，打印出每个节点的度。
    while len(graph.degree):
        importance_dict[level] = []
        while True:
            level_node_list = []
            # for item in list(graph.degree()):#graph.degree:
            #     if item[1] <= level:
            #         level_node_list.append(item[0])
            for node in list(graph.nodes()):
                degree = graph.degree(node)
                # print('degree=',degree)
                if degree <= level:
                    level_node_list.append(node)

            graph.remove_nodes_from(level_node_list)
            importance_dict[level].extend(level_node_list)
            if not len(graph.degree):
                return importance_dict
            if min(graph.degree, key=lambda x: x[1])[1] > level:
                break
        level = min(graph.degree, key=lambda x: x[1])[1]
    return importance_dict.copy()
########################################
def kshell2(G):###kshell方法将节点按照kshell方法进行的排序
    graph = G.copy()
    importance_dict = {}
    temp={}
    level = min_degree(G)
    next_level = 0
    # print('graph.degree=',graph.degree)#按照字典的形式，打印出每个节点的度。
    while len(graph.degree):
        importance_dict[level] = []
        temp[next_level]=[]
        while True:
            level_node_list = []
            for item in graph.degree:
                if item[1] <= level:
                    level_node_list.append(item[0])
            graph.remove_nodes_from(level_node_list)
            importance_dict[level].extend(level_node_list)
            # print("Level {}: {}".format(level, level_node_list))

            if not len(graph.degree):
                return importance_dict
            if min(graph.degree, key=lambda x: x[1])[1] > level:
                break
        level = min(graph.degree, key=lambda x: x[1])[1]
    return importance_dict.copy()
#####################################
def kshell_layer(G):###kshell方法将节点按照kshell方法进行的排序
    graph = G.copy()
    importance_dict = {}
    temp={}
    level = min_degree(G)
    level_t = min_degree(G)
    next_level = 0
    layer = 0
    # print('graph.degree=',graph.degree)#按照字典的形式，打印出每个节点的度。
    while len(graph.degree):
        importance_dict[level] = []
        # temp[layer]=[]
        while True:
            level_node_list = []
            for item in graph.degree:
                if item[1] <= level:
                    level_node_list.append(item[0])
            #########################
            # for node in list(graph.nodes()):
            #     degree = graph.degree(node)
            #     # print('degree=',degree)
            #     if degree <= level:
            #         level_node_list.append(node)
            #######################
            if level_t == level:
                layer += 1
            else:
                layer = 1
                level_t = level
            graph.remove_nodes_from(level_node_list)
            importance_dict[level].extend(level_node_list)
            for node in level_node_list:
                temp[node] = layer
                # print("Level {}: {}".format(node, layer))
            # print('temp=',temp)
            temp = {key: value for key, value in temp.items() if value}

            if not len(graph.degree):
                return temp
            if min(graph.degree, key=lambda x: x[1])[1] > level:
                break
        level = min(graph.degree, key=lambda x: x[1])[1]
    return temp.copy()
def Get_Min_Sub_Graph(G):
    subG = {}#用来记录去掉节点后，子图大小的一个字典。
    G_copy = G.copy()
    len_G = len(G_copy.nodes())
    Degree_G_nodes = gDegree(G)
    for k,v in Degree_G_nodes.items():
        G_copy = G.copy()#每次删除一个节点更新下G_copy
        G_copy.remove_nodes_from([k])
        SubGraphs = list(nx.connected_components(G_copy))  # 去点后，得到的剩余子图集合
        largest_subgraph = max(SubGraphs, key=len)  # 找到最大的那个子图
        subG[k] = len(largest_subgraph) / len_G
    return subG

def Get_Move_Methods_phase_SG(G):
    ###
    nums = len(G.nodes())
    largest_cc = max(nx.connected_components(G), key=len)
    # print('最大连通子图大小：=',largest_cc,'图大小',nums)
    # print('图G的基本信息：', G)
    # print('最大连通子图大小：=', len(largest_cc), '图大小', len(G))
    initial_size = len(largest_cc) / len(G)
    relative_sizes = {}#np.zeros(nums)
    relative_sizes[0] = initial_size
    G_removed = G.copy()
    phase = 10
    int_n = int(nums / 20)
    romoved_all = []
    for i in range(1,nums-1,phase):
        # list_max_to_min = dict(G_removed.degree())# 获取节点度值排序后的列表
        # list_max_to_min =Get_KPDN(G_removed)
        # list_max_to_min = KPD_Value(G_removed)
        # list_max_to_min = Get_DWT(G_removed)
        # list_max_to_min = Get_WL(G_removed)
        list_max_to_min = Get_Min_Sub_Graph(G_removed)
        # list_max_to_min = Get_WL(G_removed)
        # Get_NINL

        sorted_degrees = sorted(list_max_to_min.items(), key=lambda x: x[1], reverse=True)
        # sorted_degrees = sorted(list_max_to_min.items(), key=lambda x: x[1], reverse=False)
        # 计算要移除的节点列表
        removed_nodes = [x[0] for x in sorted_degrees[:phase]]
        # romoved_all = romoved_all.append(removed_nodes)
        romoved_all = romoved_all+removed_nodes
        # 移除节点并计算剩余网络的巨连通分支大小
        G_removed.remove_nodes_from(removed_nodes)
        if len(G_removed) == 0:
            break
        largest_cc_removed = max(nx.connected_components(G_removed), key=len)
        i_t = i+phase
        relative_sizes[i_t/nums] = len(largest_cc_removed) / nums
        phase += 1
        # phase = max(1,phase)
        if i%int_n == 0:
            print('当前进度',i_t/nums*100,'%,下降率为：',relative_sizes[i_t/nums])
    return relative_sizes,romoved_all
##########################################

def Get_CI(G):
    ci = {}
    Degree_G_nodes = gDegree(G)
    for k,v in Degree_G_nodes.items():
        set_k = set()
        ci[k] = 0
        set_k.update(set(G.neighbors(k)))
        for n1 in G.neighbors(k):
            # set_k.add(n1)
            set_k.update(set(G.neighbors(n1)))
            for n2 in G.neighbors(n1):
                set_k.update(set(G.neighbors(n2)))
        # print('set_k',k,'=',set_k)
        for node in set_k:
            ci[k] += Degree_G_nodes[node]-1
        ci[k] *= v-1
    return ci
def Get_WL(G):
    wl = {}
    Degree_G_nodes = gDegree(G)
    for k,v in Degree_G_nodes.items():
        # set_k = set()
        wl[k] = 0
        # set_k.update(set(G.neighbors(k)))
        for n1 in G.neighbors(k):
            N_Degrees = 0
            # set_k.add(n1)
            wl[k] += Degree_G_nodes[n1]
        # print('set_k',k,'=',set_k)
        wl[k] *= v
    return wl
#############################################  INCC  #############################################
##################################################################################################
def Get_N_w(G):###计算每个节点  2步长以内的  所有节点数量
    '''to get Nw'''
    N_w = {}
    Set_1st_A = []
    Set_2nd_A = []
    set_1_2_all = []
    Degree_G_nodes = gDegree(G)
    for wk,wv in Degree_G_nodes.items():
        N_w[wk] = 0
        Set_1st_A = set(G.neighbors(wk))
        for n1 in G.neighbors(wk):### n1是wk的邻居
            Set_2nd_A = set(G.neighbors(n1))
            set_1_2_all = Set_1st_A | Set_2nd_A
            # for n2 in G.neighbors(n1):### n2是n1的邻居
        N_w[wk] = len(set_1_2_all)
    return N_w
#################################################
def Get_Q(G):###计算每个节点  2步长以内的  所有节点数量
    '''to get Q'''
    N_w = Get_N_w(G)
    Q={}
    Degree_G_nodes = gDegree(G)
    for Qj,Qv in Degree_G_nodes.items():
        Q[Qj] = 0
        for n1 in G.neighbors(Qj):
            Q[Qj] += N_w[n1]
    return Q
def Get_LR(G):
    '''to get LR'''
    Q = Get_Q(G)
    LR={}
    Degree_G_nodes = gDegree(G)
    for k,v in Degree_G_nodes.items():
        LR[k] = 0
        for n1 in G.neighbors(k):
            LR[k] += Q[n1]
    return LR
def Get_PP(G):
    '''to get P' '''
    # N_w = Get_N_w(G)
    Q = Get_Q(G)
    LR = Get_LR(G)
    pp = {}
    INCC = {}
    Set_A_and_B = []
    Set_A = []
    Set_B = []
    for k,v in LR.items():
        Set_A = set(G.neighbors(k))
        for n1 in G.neighbors(k):
            Set_B = set(G.neighbors(n1))
            Set_A_and_B = Set_A & Set_B
            pp[(k,n1)] = Q[n1]/v#######    pij 这么写对不对呢？
    return pp

def Get_INCC(G):
    '''to get INCC'''
    # N_w = Get_N_w(G)
    # Q = Get_Q(G)
    G_degrees = gDegree(G)
    # LR = Get_LR(G)
    pp = Get_PP(G)
    INCCin = {}
    INCC = {}
    Set_A_and_B = []
    Set_A = []
    Set_B = []
    # for k,v in LR.items():G_degrees = gDegree(G)
    for k, v in G_degrees.items():
        Set_A = set(G.neighbors(k))
        incc_all = 0
        for n1 in G.neighbors(k):
            Set_B = set(G.neighbors(n1))
            Set_A_and_B = Set_A & Set_B
            INCCin[n1] = pp[(k,n1)]
            if len(Set_A_and_B)!= 0:
                for n2 in Set_A_and_B:
                    INCCin[n1] += pp[(k,n2)] * pp[(n2,n1)]
            incc_all += INCCin[n1]
        INCC[k] = incc_all ** 2
    return INCC
###############################################################
def Get_KPDN_INCC(G):###计算每个节点的相邻节点的度值
    """
    计算节点的重要性指数
    """
    ######### 假设这里已经算出来了 ##########
    G_KPD_Value = KPD_Value(G)
    Ks_add_D = Ks_add_D_Value(G)
    KPDN_incc = {}
    G_degrees = gDegree(G)
    Incc = Get_INCC(G)
    Set_A = []
    Set_B = []
    for k, v in G_degrees.items():
        KPDN_incc[k] = {}
        Neighbor = []
        E = 0
        Sum_KPD_E = 0
        Set_A = set(G.neighbors(k))
        for i in G.neighbors(k):### 返回k节点的所有邻居节点
            Set_B = set(G.neighbors(i))
            # E = len(Set_A & Set_B)/len(Set_A | Set_B)
            # E = (len(Set_A & Set_B)) / (len(Set_A | Set_B) + 1)
            # E = (len(Set_A & Set_B)) / (((v**2+G_degrees[i]**2)/2)**0.5)
            E = (len(Set_A & Set_B)) / ((v * G_degrees[i]) ** 0.5)
            # E = (len(Set_A & Set_B) + 1) / ((G_degrees[k]*G_degrees[i])**0.5)
            # E = (len(Set_A & Set_B) + 1) / ((G_KPD_Value[k] * G_KPD_Value[i]) ** 0.5)
            # Sum_KPD_E += E*G_KPD_Value[i]
            # Sum_KPD_E += ((E+1)/v)**2#E * G_KPD_Value[i]
            # Sum_KPD_E += (E + 1) ** 3  # E * G_KPD_Value[i]
            # Sum_KPD_E += ((E+1)/G_KPD_Value[i]) ** 2  # E * G_KPD_Value[i]!!!!!!!!!!!!!!!这个结果蛮好的！！！！！！！！！约等于DWT
            # Sum_KPD_E += ((E) / G_KPD_Value[i]) ** 2  # E * G_KPD_Value[i]!!!!!!!!!!!!!!!这个结果蛮好的！！！！！！！！！约等于DWT
            # Sum_KPD_E += ((E+1)/G_KPD_Value[i]) ** 2+((E) / G_KPD_Value[i]) ** 2  # E * G_KPD_Value[i]!!!!!!!!!!!!!!!这个结果蛮好的！！！！！！！！！约等于DWT
            # Sum_KPD_E += ((E + 1) / G_KPD_Value[i]) ** 2 + ((E + 1) / v) ** 2
            # Sum_KPD_E += ((E + 1) / G_KPD_Value[i]) ** 2 + (E / v) ** 2
            # Sum_KPD_E += ((E + 2) / v) ** 2  # + ((E + 1) / v) ** 2
            # Sum_KPD_E += ((E + v) / G_KPD_Value[i]) ** 2  # + ((E + 1) / v) ** 2
            # Sum_KPD_E += (E ** 2 + v ** 2) / G_KPD_Value[i]** 2 #) ** 2  # + ((E + 1) / v) ** 2
            # Sum_KPD_E += ((Incc[i] * E + v) / G_KPD_Value[i])** 2  # ) ** 2  # + ((E + 1) / v) ** 2！！结果可以
            # Sum_KPD_E += ((Incc[i] + v) / G_KPD_Value[i]) ** 2 # ) ** 2  # + ((E + 1) / v) ** 2！！power结果可以
            # Sum_KPD_E += ((Incc[i] + v) / G_KPD_Value[i]) ** 2 * E  # ) ** 2  # + ((E + 1) / v) ** 2
            # Sum_KPD_E += ((Incc[i] + E) / G_KPD_Value[i]) ** 2# ) ** 2  # + ((E + 1) / v) ** 2！！power结果可以
            # Sum_KPD_E += ((Incc[i] + v) / (G_KPD_Value[i] * E + 0.01)) ** 2#大概50%的位置突变了一下，因此我们断定肯定是有更好的方法的。
            # Sum_KPD_E += ((Incc[i] + v) / (G_KPD_Value[i] * E + 1)) ** 2###这个结果很棒！对于us-airpoarts数据
            # Sum_KPD_E += ((Incc[i] + G_KPD_Value[i]) / (v * E + 1)) ** 2#效果贼差
            # Sum_KPD_E += ((Incc[i] + v) / (G_KPD_Value[i] * E + 1)) #** 2  ###这个结果很棒！对于us-airpoarts数据
            # Sum_KPD_E += ((Incc[i] * v) / (G_KPD_Value[i] * E + 1)) ** 2  ###这个结果很棒！对于us-airpoarts数据!!!
            # Sum_KPD_E += ((Incc[i] * v) / (Ks_add_D[i] * E + 1)) ** 2  ###这个结果很棒！对于us-airpoarts数据!!!!!可以可以，感觉似乎emmm原来kshell详细分解后没啥用
            # Sum_KPD_E += ((Incc[i] * Ks_add_D[i]) / ((G_KPD_Value[i]-v) * E + 1)) ** 2  ###这个结果很棒！对于us-airpoarts数据
            Sum_KPD_E += ((Incc[i] * v) / (Ks_add_D[i] * E + 1)) ** 4  #

        KPDN_incc[k] = Sum_KPD_E
            # Sum_KPD_E += (E / G_KPD_Value[i]) #** 2  # + ((E + 1) / v) ** 2
            # Sum_KPD_E += ((E + 1) / G_KPD_Value[i]) ** 2 + ((E) / G_KPD_Value[i]) ** 2 + (1 / G_KPD_Value[i]) ** 2  # E * G_KPD_Value[i]!!!!!!!!!!!!!!!这个结果蛮好的！！！！！！！！！约等于DWT
        # KPDN_incc[k] = Sum_KPD_E
        # print("node {}: E:{}".format(k, KPDN[k]))
    return KPDN_incc.copy()

####################################################################
######################## 改进后的重力plus算法 #########################
####################################################################
def Get_H_index(G):#获得H指数
    degrees = dict(G.degree())
    degs = sorted(degrees.values(),reverse =True)
    # h = 0
    H_index = {}
    for k,v in degrees.items():
        h = 0
        H_index[k] = 0
        for d in G.neighbors(k):
            if d >= h+1:
                h += 1
            else:
                break
        H_index[k] = h
    return H_index


def Get_M(G):
    M = {}
    H_index = Get_H_index(G)
    Kshell = get_Node_ks_v_k(G)#计算每个节点对应的K-shell值
    average_ks = 0
    average_H = 0
    for k1,v1 in H_index.items():
        average_H += v1
        average_ks += Kshell[k1]
    # for k2,v2 in Kshell.items():
    #     average_ks += v2
    lamuda = average_ks/average_H
    for k,v in Kshell.items():
        M[k] = v + lamuda * H_index[k]
    return M
def KSL_Value(G):
    '''计算KPD的值'''
    pass
    G_degrees = gDegree(G)#计算每个节点的度值
    G_Kshell = kshell2(G)#计算不同kshell下的节点，也就是 计算 kshell 的过程
    G_node_Kshell = get_Node_ks_v_k(G)#计算每个节点  对应的kshell值
    G_kshell_layer = kshell_layer(G)#计算每个节点所在的  kshell的  layer值
    G_get_Node_neighbor_ks_max = get_Node_neighbor_ks_max(G1)#计算节点邻居的最大kshell值
    G_max_layer = max_layer(G)#计算出各节点的  最大layer值
    G_max_neighbor_degree = get_Node_neighbor_degree_max(G)
    KSL_Node = {}
    KsKSL_Node = {}
    for k, v in G_kshell_layer.items():
        KSL_Node[k] = v / (1+G_max_layer[k])*max(1,G_get_Node_neighbor_ks_max[k]-G_node_Kshell[k])
    # print('KSL_Node=',KSL_Node)
    for k, v in G_node_Kshell.items():
        # KPD_Node[k] = v + KSL_Node[k]*(1+G_degrees[k]/(G_max_neighbor_degree[k]+1))
        # KPD_Node[k] = v + KSL_Node[k] + G_degrees[k] / (G_max_neighbor_degree[k] + 1) * G_max_neighbor_degree[k]
        # KPD_Node[k] = G_degrees[k] + v + KSL_Node[k]*(G_degrees[k]/(G_max_neighbor_degree[k]+1))######!!!!!!!!!!!!!!!!震惊！！！这个方法居然挺好
        KsKSL_Node[k] = v + KSL_Node[k] * (G_degrees[k] / (G_max_neighbor_degree[k] + 1))######!!!!!!!!!!!!!!!!震惊！！！这个方法居然挺好
        # KPD_Node[k] = v + KSL_Node[k] + G_degrees[k] / (G_max_neighbor_degree[k] + 1) * KSL_Node[k]
        # KPD_Node[k] = v + KSL_Node[k] * G_degrees[k] / (G_max_neighbor_degree[k] + G_degrees[k] + 1)
    return KsKSL_Node.copy()
def Get_M2(G):
    M = {}
    H_index = Get_H_index(G)
    Kshell = KSL_Value(G)#计算每个节点对应的K-shell值
    average_ks = 0
    average_H = 0
    for k1,v1 in H_index.items():
        average_H += v1
        average_ks += Kshell[k1]
    # for k2,v2 in Kshell.items():
    #     average_ks += v2
    lamuda = average_ks/average_H
    for k,v in Kshell.items():
        M[k] = v + lamuda * H_index[k]
    return M
def Get_W1(G):###原始的结构洞公式
    structural_holes = Get_structuct_holes(G)#这一步得到比较好的结构洞值（nature2019年的那篇改进的结构洞参数）
    W = {}
    for k,v in structural_holes.items():
       W[k] = math.exp(0 - v) / 2
    return W
def Get_W2(G):###基于2020nature的结构洞公式
    structural_holes = Get_INCC(G)#这一步得到比较好的结构洞值（2019年的 Nature的那篇改进的结构洞参数）
    W = {}
    for k,v in structural_holes.items():
       W[k] = math.exp(0-v)/2
    return W
# from functools import partial
def Get_distance(G, nbunch=None, distance=None, sources=None):
    nbunch = set(G.nbunch_iter(nbunch)) if nbunch is not None else set(G.nodes)
    sources = set(G.nbunch_iter(sources)) if sources is not None else G.nodes
    centrality = {}

    spl = partial(nx.shortest_path_length, G, weight=distance)
    # centrality = {(u,v): 0 for u,v in nbunch}
    for n1 in nbunch:
        for n2 in nbunch:
            centrality[(n1,n2)] = 0
    for v in sources:
        dist = spl(v)
        for u in nbunch.intersection(dist):
            d = dist[u]
            if d == 0:  # handle u == v and edges with 0 weight
                d = 10
                continue
            centrality[(v,u)] = max(1 / d ,0)
    return centrality

###########
def Get_Uij(G):
    G_degrees = gDegree(G)
    Uij = {}
    for k,v in G_degrees.items():
        Set_A = set(G.neighbors(k))
        for n1 in G.neighbors(k):
            Uij[(k, n1)] = 1 / (v+1)
        # Uij[k] = 1/(v+1)
    return Uij

def Get_structuct_holes(G):
    # N_w = Get_N_w(G)
    # Q = Get_Q(G)
    G_degrees = gDegree(G)
    # LR = Get_LR(G)
    U = Get_Uij(G)
    S_Holein = {}
    S_Hole = {}
    Set_A_and_B = []
    Set_A = []
    Set_B = []
    # for k,v in LR.items():G_degrees = gDegree(G)
    for k, v in G_degrees.items():
        Set_A = set(G.neighbors(k))
        S_Hole_all = 0
        for n1 in G.neighbors(k):
            Set_B = set(G.neighbors(n1))
            Set_A_and_B = Set_A & Set_B
            S_Holein[n1] = U[(k,n1)]
            if len(Set_A_and_B)!= 0:
                for n2 in Set_A_and_B:
                    S_Holein[n1] += U[(k,n2)] * U[(n2,n1)]
            S_Hole_all += S_Holein[n1]
        S_Hole[k] = S_Hole_all ** 2
    return S_Hole
###########

def Get_ISM(G):###阮教授 提到的比较2022年的传播特性方法
    ISM = {}
    d = Get_distance(G)
    W = Get_W1(G)#使用原始结构洞构成
    # W = Get_W2(G)#使用2019 Nature的结构洞构成
    M = Get_M(G)
    Degree_G_nodes = gDegree(G)
    for k,v in M.items():
        set_k = set()
        ISM[k] = 0
        set_k.update(set(G.neighbors(k)))
        for n1 in G.neighbors(k):
            # set_k.add(n1)
            set_k.update(set(G.neighbors(n1)))
            for n2 in G.neighbors(n1):
                set_k.update(set(G.neighbors(n2)))
                # for n3 in G.neighbors(n1):
                #     set_k.update(set(G.neighbors(n3)))
        # print('set_k',k,'=',set_k)
        for node in set_k:
            ISM[k] += W[node] * v * M[node] * d[(k,node)]
    return ISM
# def Get_IGKHS(G):####我们提到的比较新的传播特性方法
#     IGKHS = {}
#     d = Get_distance(G)
#     # W = Get_W1(G)#使用原始结构洞构成
#     W = Get_W2(G)#使用2019 Nature的结构洞构成
#     M = Get_M(G)
#     # M = Get_M2(G)
#     Degree_G_nodes = gDegree(G)
#     for k,v in M.items():
#         set_k = set()
#         IGKHS[k] = 0
#         set_k.update(set(G.neighbors(k)))
#         for n1 in G.neighbors(k):
#             # set_k.add(n1)
#             set_k.update(set(G.neighbors(n1)))
#             for n2 in G.neighbors(n1):
#                 set_k.update(set(G.neighbors(n2)))
#                 # for n3 in G.neighbors(n1):
#                 #     set_k.update(set(G.neighbors(n3)))
#         # print('set_k',k,'=',set_k)
#         for node in set_k:
#             IGKHS[k] += W[node] * v * M[node] * d[(k,node)]
#     return IGKHS

def Get_M_UP(G_list):
    '''To get monotonicity'''
    k = 0
    sum_k = 0
    result_M = 0
    lenth_G = len(G_list)
    for i in range(lenth_G-1):
        if G_list[i] == G_list[i + 1]:
            k += 1
        else:
            sum_k += k * (k - 1)
            k = 0
    result_M = (1-sum_k/(lenth_G*(lenth_G-1)))**2
    return result_M
###################  验证方法1___子图剩余规模率  ####################
def kill_nodes_Find_max_Sub_Graph(G,list_nodes):
    '''To get Maximum Connectivity Coefficient'''
    subG = {}#用来记录去掉节点后，子图大小的一个字典。
    G_copy = G.copy()
    len_G = len(G_copy.nodes())
    lenth = len(list_nodes)
    lenth_100 = int(lenth / 100)
    # i = 0
    lenth = len(list_nodes)
    for i in range(lenth-1):
        G_copy.remove_nodes_from([list_nodes[i]])#首先根据list去依次移除可能的重要排序节点
        SubGraphs = list(nx.connected_components(G_copy))#去点后，得到的剩余子图集合
        largest_subgraph = max(SubGraphs,key = len)#找到最大的那个子图
        # i=i+1
        if i % lenth_100 == 0:
            subG[i/len_G] = len(largest_subgraph)/len_G
    return subG
##########################################
###################  验证方法3___子图连边剩余率  ####################
def kill_nodes_Find_Sub_Graph_edges_efficiency(G, list_nodes):
    '''To get Average remaining edges of the network'''
    subG = {}  # 用来记录去掉节点后，子图大小的一个字典。
    G_copy = G.copy()
    len_G = len(G_copy.nodes())
    # i = 0
    lenth = len(list_nodes)
    lenth_100 = int(lenth/100)
    G_num_edges = G.number_of_edges()#原图G中的总边数
    for i in range(lenth - 1):
        G_copy.remove_nodes_from([list_nodes[i]])  # 首先根据list去依次移除可能的重要排序节点
        Gsub_num_edges = G_copy.number_of_edges()
        if i % lenth_100 == 0:
            subG[i / len_G] = Gsub_num_edges / G_num_edges
        # SubGraphs_nodes = list(nx.connected_components(G_copy))  # 去点后，得到的剩余子图集合
        # largest_subgraph = max(SubGraphs_nodes, key=len)  # 找到最大的那个子图
        # i=i+1
        # subG[i / len_G] = len(largest_subgraph) / G_num_edges
    return subG
#####################################################################
##################  验证方法4___网络敏感率  ####################
def kill_nodes_Susceptibility_value(G,list_nodes):
    '''To get Network sensitivity'''
    subG = {}#用来记录去掉节点后，子图大小的一个字典。
    G_copy = G.copy()
    len_G = len(G_copy.nodes())
    # len_G_20 = len(G_copy.nodes())
    # i = 0
    lenth = len(list_nodes)
    lenth_100 = int(len(list_nodes)/100)
    for i in range(lenth-1):
        v_sum = 0
        G_copy.remove_nodes_from([list_nodes[i]])#首先根据list去依次移除可能的重要排序节点
        # SubGraphs_nodes = list(nx.connected_components(G_copy))#去点后，得到的剩余子图集合
        ns = 0
        if i % lenth_100 == 1:
            lenth_SubGraph = len_G - i
            SubGraphs_nodes = list(nx.connected_components(G_copy))  # 去点后，得到的剩余子图集合
            for subnet_ns in SubGraphs_nodes:
                if len(subnet_ns) <= len_G*0.99:
                    v_sum += len(subnet_ns)**2 / lenth_SubGraph
                    ns += 1
            subG[i/len_G] = v_sum * ns
    return subG



print("0.The task starts！  ------------------------------------------")
##########################################
##########################################
# G4 = nx.Graph()
# G4.add_edges_from([(1,2),(1,3),(2,3),(2,4),(8,5),(4,5),(5,6),(5,7),(6,7)])
# print('kshell(g4)=',kshell(G4))
global title_G1
##############  mtx  networks  #################################################
# title_G = "power-US-Grid.mtx"
# title_G = "power-eris1176.mtx"
# title_G = "power-bcspwr10.mtx"
# title_G = "power-685-bus.mtx"
# title_G = "road-chesapeake.mtx"
# title_G = "econ-beause.mtx"
# title_G = "econ-poli.mtx"
# title_G = "web-polblogs.mtx"
# title_G = "web-spam.mtx"
# title_G = "ca-netscience.mtx"
# title_G = "tech-routers-rf.mtx"
# title_G = "socfb-Simmons81.mtx"
# title_G = "socfb-UChicago30.mtx"
# title_G = "socfb-Hamilton46.mtx"
# title_G = "frb30-15-1.mtx"
# title_G = "frb30-15-2.mtx"
# title_G = "frb30-15-3.mtx"
# title_G = "web-edu.mtx"
# title_G = "road-minnesota.mtx"


# #
# matrix = sio.mmread(title_G)##将 mtx 稀疏矩阵 转化为 Graph图像
# G1 = nx.from_scipy_sparse_array(matrix)
# title_G1 = title_G[:-4]#去掉'.edges'后缀
##############  edges_weight networks  #################################################

# title_G_W = "email-univ.edges"
# title_G_W = "email-dnc.edges"
# title_G_W = "rt_damascus.edges"
# title_G_W = "rt_barackobama.edges"
# title_G_W = "rt_bahrain.edges"
# title_G_W = "rt_assad.edges"
# title_G_W = "US-airports.edges"
# title_G_W = "mammalia-voles-rob-trapping.edges"
# title_G_W = "reptilia-tortoise-network-fi.edges"
# title_G_W = "aves-weaver-social.edges"
# title_G_W = "aves-wildbird-network.edges"
# title_G_W = "ia-reality-call.edges"
#

# G1 = nx.read_weighted_edgelist(title_G_W,create_using=nx.DiGraph)
# title_G1 = title_G_W[:-6]#去掉'.edges'后缀


# title_G_W = "aves-wildbird-network.edges"
# title_G_W = "ia-reality-call.edges"
##############  '''big data 10^4-10^5 ''' #################################################

# title_G_W = "sx-mathoverflow-w.edges"
# title_G_W = "edit-thwikibooks-w.edges"
# title_G_W = "facebook-wosn-links.edges"
# title_G_W = "facebook-wosn-links.edges"
# title_G_W = "facebook-wosn-wall.edges"
title_G_W = "flickrEdges.edges"
# title_G_W = "gottron-reuters.edges"
# title_G_W = "jester2.edges"
# title_G_W = "petster-cat-household.edges"
# title_G_W = "prosper-loans.edges"
#
edges = []
with open(title_G_W) as f:
    for line in f:
        n1, n2 = line.split()[0:2] # 只读取前两字段
        edges.append((n1, n2))

G1 = nx.Graph()
G1.add_edges_from(edges)
title_G1 = title_G_W[:-6]#去掉'.edges'后缀
##############  edges networks  #################################################

# title_G = "inf-openflights.edges"
# title_G = 'fb-pages-tvshow.edges'
# title_G = "facebook_1912.edges"
# title_G = "facebook_combined.edges"
# title_G = "fb-pages-government.edges"
# title_G = "ia-crime-moreno.edges"
# title_G = "fb-pages-company.edges"
# title_G = "p2p-Gnutella08.edges"
# title_G = "p2p-Gnutella25.edges"
# title_G = "p2p-Gnutella09.edges"
# title_G = "bio-grid-worm.edges"
# title_G = "inf-euroroad.edges"
# title_G = "soc-hamsterster.edges"
# title_G = "bn-mouse_brain_1.edges"
# title_G = "bn-fly-drosophila_medulla_1.edges"
# title_G = "bn-macaque-rhesus_brain_1.edges"
# title_G = "socfb-nips-ego.edges"
# title_G = "dimacs10-astro-ph.edges"
# title_G = "soc-Epinions1.edges"
# title_G = "ca-Astroph.edges"
# title_G = "escorts.edges"



# G1 = nx.read_edgelist(title_G)
# title_G1 = title_G[:-6]#去掉'.edges'后缀
##############  gml  networks  #################################################
# title_G_gml = 'power.gml'
# title_G_gml = 'inf-power.gml'
# title_G_gml = 'inf-USAir97.gml'

# G1 = nx.read_gml(title_G_gml,label="id")
# title_G1 = title_G_gml[:-4]#去掉'.edges'后缀
##############  LFR network  #################################################
#
# n = 2000
# tau1 = 3# 度分布幂律指数
# tau2 = 1.5# 社区内部节点度分布幂律指数
# mu = 0.3# 边交叉概率
# G1 = LFR_benchmark_graph(n, tau1, tau2, mu, average_degree=9,min_community=60, seed=10)
# title_G1 = 'LFR-2000-9 '

##############  LFR network   #################################################

# n = 1000
# tau1 = 6# 度分布幂律指数
# tau2 = 3# 社区内部节点度分布幂律指数
# mu = 0.8# 边交叉概率
# G1 = LFR_benchmark_graph(n, tau1, tau2, mu, average_degree=30,min_community=10, seed=10)
# title_G1 = 'LFR-2000-20 '

##############  ER  network   #################################################

# n = 1000
# p = 0.03
# G1 = nx.erdos_renyi_graph(n, p)
# title_G1 = 'Erdős-Rényi-1000 '

##############  watts network   #################################################

# G_1 = nx.fast_gnp_random_graph(20, 0.52)
# G1 = nx.watts_strogatz_graph(1000, 4, 0.9)
# G1 = nx.disjoint_union(G_1, G_2)
# G_1 = nx.watts_strogatz_graph(800, 8, 0.5)
# G_2 = nx.watts_strogatz_graph(800, 6, 0.5)
# G1 = nx.disjoint_union(G_1, G_2)
# G1 = nx.watts_strogatz_graph(500, 20, 0.9)
# title_G1 = 'watts_strogatz-500-20'

##############  barabasi network   #################################################

# n,m = 500,30
# G1= nx.barabasi_albert_graph(n,m)###巴拉巴西---阿尔伯特网络，比较好玩的一个网络，就是首先你有m各节点然后后面每次将新节点，与已有节点中的m个节点相连，最后直到添加到n个节点时。
# # #转化为无向图
# # G1=G1.to_undirected()
# nx.write_gml(G1, 'bala_Graph.gml')
# title_G1 = 'barabasi albert-500-30'

##############  save  networks   #################################################
# save as gml file
G1=G1.to_undirected()
# nx.write_gml(G1, '1'+title_G1+'.gml')
nx.write_edgelist(G1, '3'+title_G1+'.edges')
print('The backup of the edges version data has been completed！！！')
# # 绘制网络图
#############################################################################
print("1.Reminder: The data is about to be imported, please confirm again    -------------------------------------------")
# print('G1=',G1)
# print('图的基本信息G1：',G1.info())
len_nodes = G1.number_of_nodes()
len_edges = G1.number_of_edges()
G_copy = G1.copy()
avg_clustering = nx.average_clustering(G1)
# 打印网络基本信息
print("=================================================================")
# 打印网络基本信息
print("------Name：", title_G1)
print("------Number of nodes:", len_nodes)
print("------Edges of nodes:", len_edges)
print("------Average degree:", len_edges/len_nodes)
print("------Network density:", len_edges/(len_nodes-1)/len_nodes)
print("---Average clustering coefficient：", avg_clustering)
print("=================================================================")
# print("节点的度数中心性:", nx.degree_centrality(G1))
subgraphs_nodessets = list(nx.connected_components(G_copy))
###这里又创造出两个新功能，子图节点集  和  子图节点集构成的子图
# diameter = nx.diameter(subgraphs)
# # 计算每个子图的直径
# diameters = []
# for subgraphs_nodesset in subgraphs_nodessets:
#     subgraph = G1.subgraph(subgraphs_nodesset)
#     diameter = nx.diameter(subgraph)
#     diameters.append(diameter)
# # 找到最大的直径
# max_diameter = max(diameters)
# # print("网络直径为：", diameter)
# print("网络直径:", max_diameter)
print(" ")
print("2.Data preparation----------------------------------------------------------------")
#############################################################################
# print('Degree(G1)=',G1.degree())
# print('kshell2(G1)=',kshell2(G1))
# print('kshell_layer(G1)=',kshell_layer(G1))
# print('KPD_Value(G)=',KPD_Value(G1))
# list_key_value = dict(sorted(Get_KPDN(G1).items(), key=operator.itemgetter(1)))
# # print('G的度值(G1)=',gDegree(G1))
# # print('Get_KPDN(G)=',Get_KPDN(G1))
# print('排序后：Get_KPDN(G)=',dict(sorted(Get_KPDN(G1).items(), key=operator.itemgetter(1))))#0按照键排序，1按照值排序
# list_key_value_KPD = dict(sorted(KPD_Value(G1).items(), key=operator.itemgetter(1)))
# print('排序后：KPD_Value(G)=',list_key_value_KPD)
# # list_DWT3 = dict(sorted(Get_DWT_3(G1).items(), key=operator.itemgetter(1)))
# # print('排序后：list_DWT=',list_DWT3)
# # list_Move_Methods = dict(sorted(Get_Move_Methods(G1).items(), key=operator.itemgetter(1)))
# # list_Move_Methods = Get_Move_Methods(G1)#dict(sorted(Get_Move_Methods(G1).items(), key=operator.itemgetter(1)))
# # list_Move_Methods_DC = Get_Move_Methods_DC(G1)#dict(sorted(Get_Move_Methods(G1).items(), key=operator.itemgetter(1)))
# # print('排序后：list_DYN_KPD=',list_Move_Methods)
# # print('排序后：list_DYN_DC=',list_Move_Methods_DC)
# # list_DWT2 = dict(sorted(Get_DWT2(G1).items(), key=operator.itemgetter(1)))
# # print('排序后：list_DWT2=',list_DWT2)
# list_DWT = dict(sorted(Get_DWT(G1).items(), key=operator.itemgetter(1)))
# print('排序后：list_DWT=',list_DWT)
# list_CI = dict(sorted(Get_CI(G1).items(), key=operator.itemgetter(1)))
# print('排序后：list_CI=',list_CI)
# list_WL = dict(sorted(Get_WL(G1).items(), key=operator.itemgetter(1)))
# print('排序后：list_WL=',list_WL)
# # compute_ci(G)
#
# # Get_DWT_3

# print("----------------------------------------------------------------")
########################################################
list_kpd = []
list_kpd2 = []
list_key_value_KPD = dict(sorted(KPD_Value(G1).items(), key=operator.itemgetter(1)))
for k,v in list_key_value_KPD.items():
    list_kpd.append(k)
    list_kpd2.append(v)
# print('list_KPD=',list_kpd)
print('10%---list_KPD ---Node sorting completed！')
####################################
list_kpdn = []
list_kpdn2 = []
list_key_value = dict(sorted(Get_KPDN(G1).items(), key=operator.itemgetter(1)))
for k,v in list_key_value.items():
    list_kpdn.append(k)
    list_kpdn2.append(v)
# print('list_KPDN=',list_kpdn)
print('20%---list_KPDN ---Node sorting completed！')
#############################################
D_list_value = []
D_list_value2 = []

D_list_key_value = dict(sorted(gDegree(G1).items(), key=operator.itemgetter(1)))
for k,v in D_list_key_value.items():
    D_list_value.append(k)
    D_list_value2.append(v)
# print('list_degree=',D_list_value)
print('30%---list_degree ---Node sorting completed！')
#############################################
Kshell_list_value = []
Kshell_list_value2 = []
Kshell_list_key_value = dict(sorted(get_Node_ks_v_k(G1).items(), key=operator.itemgetter(1)))
for k,v in Kshell_list_key_value.items():
    Kshell_list_value.append(k)
    Kshell_list_value2.append(v)
# print('list_Kshell=',Kshell_list_value)
print('40%---list_Kshell ---Node sorting completed！')
###  计算介数中心性 BC
# bc = nx.betweenness_centrality(G1)
# ###  接近中心性 CC
# cc = nx.closeness_centrality(G1)
# CC_list_value = []
# CC_list_value2 = []
# CC_list_key_value = dict(sorted(nx.closeness_centrality(G1).items(), key=operator.itemgetter(1)))
# for k,v in CC_list_key_value.items():
#     CC_list_value.append(k)
#     CC_list_value2.append(v)
# # print('list_CC=',CC_list_value)
# print('50%---list_CC 方法---节点排序 完成！')
#############################################
# BC_list_value = []
# BC_list_value2 = []
# BC_list_key_value = dict(sorted(nx.betweenness_centrality(G1).items(), key=operator.itemgetter(1)))
# for k,v in BC_list_key_value.items():
#     BC_list_value.append(k)
#     BC_list_value2.append(v)
# # print('list_BC=',BC_list_value)
# print('60%---list_BC 方法---节点排序 完成！')
#############################################
DWT_list_value = []
DWT_list_value2 = []
DWT_list_key_value = dict(sorted(Get_DWT(G1).items(), key=operator.itemgetter(1)))
for k,v in DWT_list_key_value.items():
    DWT_list_value.append(k)
    DWT_list_value2.append(v)
# print('list_DWT3=',DWT_list_value)
print('70%---list_DWT ---Node sorting completed！')
#############################################
CI_list_value = []
CI_list_value2 = []
list_CI = dict(sorted(Get_CI(G1).items(), key=operator.itemgetter(1)))
for k,v in list_CI.items():
    CI_list_value.append(k)
    CI_list_value2.append(v)
# print('list_CI=',CI_list_value)
print('80%---list_CI ---Node sorting completed！')
#############################################
WL_list_value = []
WL_list_value2 = []
list_WL = dict(sorted(Get_WL(G1).items(), key=operator.itemgetter(1)))
for k,v in list_WL.items():
    WL_list_value.append(k)
    WL_list_value2.append(v)
# print('list_WL=',WL_list_value)
print('90%---list_WL ---Node sorting completed！')
#############################################
# HC_list_value = []
# HC_list_value2 = []
# HC_list_key_value = dict(sorted(nx.harmonic_centrality(G1).items(), key=operator.itemgetter(1)))
# for k,v in HC_list_key_value.items():
#     HC_list_value.append(k)
#     HC_list_value2.append(v)
# # print('list_HL=',HL_list_value)
# print('95%---list_HC 方法---节点排序 完成！')
#############################################
INCC_list_value = []
INCC_list_value2 = []
INCC_list_key_value = dict(sorted(Get_INCC(G1).items(), key=operator.itemgetter(1)))
for k,v in INCC_list_key_value.items():
    INCC_list_value.append(k)
    INCC_list_value2.append(v)
# print('list_HL=',HL_list_value)
print('96%---list_INCC ---Node sorting completed！')

# Get_KPDN_INCC(G)
#############################################
# SG_list_value = []
# SG_list_key_value = dict(sorted(Get_Min_Sub_Graph(G1).items(), key=operator.itemgetter(1)))
# for k,v in SG_list_key_value.items():
#     SG_list_value.append(k)
# # print('list_HL=',HL_list_value)
# print('98%---list_Min_Sub_G 方法---节点排序 完成！')

#############################################
KPDN_INCC_list_value = []
KPDN_INCC_list_value2 = []
KPDN_INCC_list_key_value = dict(sorted(Get_KPDN_INCC(G1).items(), key=operator.itemgetter(1)))
for k,v in KPDN_INCC_list_key_value.items():
    KPDN_INCC_list_value.append(k)
    KPDN_INCC_list_value2.append(v)
# print('list_HL=',HL_list_value)
print('97%---KPDN_INCC ---Node sorting completed！')
#############################################
PR_list_value = []
PR_list_value2 = []
PR_list_key_value = dict(sorted(nx.pagerank(G1, alpha=0.80).items(), key=operator.itemgetter(1)))
for k,v in PR_list_key_value.items():
    PR_list_value.append(k)
    PR_list_value2.append(v)
# print('list_HL=',HL_list_value)
print('99%---Pagerank ---Node sorting completed！')
#############################################
Random_list_value = D_list_value.copy()
Random_list_value2 = D_list_value2.copy()
random.shuffle(Random_list_value)
random.shuffle(Random_list_value)
random.shuffle(Random_list_value2)
random.shuffle(Random_list_value2)
# print('list_Random=',Random_list_value)
print('100%---对照组：list_Random  ---Node sorting completed！')
print(' ')
print("3.Calculate the collapse rate of each method ----------------------------------------------------------------")
print("  3_1.Calculate the collapse rate of the network ___ the largest connected subgraph coefficient ----------------------------------------------")
########################################################################################
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
line1 = kill_nodes_Find_max_Sub_Graph(G1,list_kpd[::-1])
print("10%---KPD Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
line2 = kill_nodes_Find_max_Sub_Graph(G1,list_kpdn[::-1])
print("20%---KPDN Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
# largest_kpdn = kill_nodes_Find_max_Sub_Graph(G1,list_kpdn)
line3 = kill_nodes_Find_max_Sub_Graph(G1,D_list_value[::-1])
print("30%---Degree Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
line4 = kill_nodes_Find_max_Sub_Graph(G1,Kshell_list_value[::-1])
print("40%---KShell Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
# line5 = kill_nodes_Find_max_Sub_Graph(G1,CC_list_value[::-1])
# print("50%---CC Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
# line5 = kill_nodes_Find_max_Sub_Graph(G1,BC_list_value[::-1])
# print("60%---BC Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
line6 = kill_nodes_Find_max_Sub_Graph(G1,DWT_list_value)
print("70%---DWT Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
line7 = kill_nodes_Find_max_Sub_Graph(G1,CI_list_value[::-1])
print("80%---CI Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
line8 = kill_nodes_Find_max_Sub_Graph(G1,WL_list_value[::-1])
print("90%---WL Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
# line13 = kill_nodes_Find_max_Sub_Graph(G1,HC_list_value[::-1])
# print("95%---HC Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
line9 = kill_nodes_Find_max_Sub_Graph(G1,INCC_list_value[::-1])
print("97%---INCC Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
# line15 = kill_nodes_Find_max_Sub_Graph(G1,SG_list_value[::-1])
# print("98%---SG 崩坏率计算完成")
# line16 = kill_nodes_Find_max_Sub_Graph(G1,KPDN_INCC_list_value[::-1])
# print("98%---KPDNCC 崩坏率计算完成")
line10 = kill_nodes_Find_max_Sub_Graph(G1,PR_list_value[::-1])
print("99%---Pagerank Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
line11 = kill_nodes_Find_max_Sub_Graph(G1,Random_list_value)
print("100%---Random Calculate the collapse rate of the network ___ the largest connected subgraph coefficient")
########################################################################################
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
print("  3_2.Calculate the the Network monotonicity ----------------------------------------------")
M_KPD = Get_M_UP(list_kpd2)
M_KPDN = Get_M_UP(list_kpdn2)
M_DC = Get_M_UP(D_list_value2)
M_Kshell = Get_M_UP(Kshell_list_value2)
# M_CC = Get_M_UP(CC_list_value2)
# M_BC = Get_M_UP(BC_list_value2)
M_DWT = Get_M_UP(DWT_list_value2)
M_CI = Get_M_UP(CI_list_value2)
M_WL = Get_M_UP(WL_list_value2)
# M_HC = Get_M_UP(HC_list_value2)
M_INCC = Get_M_UP(INCC_list_value2)
M_PR = Get_M_UP(PR_list_value2)
M_Rand = Get_M_UP(Random_list_value2)
print('M_KPD:',M_KPD)
print('M_KPDN:',M_KPDN)
print('M_DC:',M_DC)
print('M_KSHELL:',M_Kshell)
# print('M_CC:',M_CC)
# print('M_BC:',M_BC)
print('M_DWT:',M_DWT)
print('M_CI:',M_CI)
print('M_WL:',M_WL)
# print('M_HC:',M_HC)
print('M_INCC:',M_INCC)
print('M_PR:',M_PR)
print('M_Rand:',M_Rand)
########################################################################################
print("  3_3.Calculate the collapse rate of the network ___ the remaining number of edges----------------------------------------------")
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
line2_1 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,list_kpd[::-1])#[::-1]KPD
print("10%---KPD Collapse rate calculation completed")
line2_2 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,list_kpdn[::-1])#[::-1]kshell
print("20%---KPDN Collapse rate calculation completed")
line2_3 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,D_list_value[::-1])#[::-1]kshell
print("30%---degree Collapse rate calculation completed")
line2_4 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,Kshell_list_value[::-1])#[::-1]kshell
print("40%---Kshell Collapse rate calculation completed")
# line2_5 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,CC_list_value[::-1])#[::-1]kshell
# print("50%---CC 崩坏率计算完成")
line2_6 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,DWT_list_value)#[::-1]kshell
print("60%---DWT Collapse rate calculation completed")
line2_7 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,CI_list_value[::-1])#[::-1]kshell
print("70%---CI Collapse rate calculation completed")
line2_8 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,WL_list_value[::-1])#[::-1]kshell
print("80%---WL Collapse rate calculation completed")
line2_9 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,INCC_list_value[::-1])#[::-1]kshell
print("90%---INCC Collapse rate calculation completed")
line2_10 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,PR_list_value[::-1])#[::-1]kshell
print("91%---Pagerank Collapse rate calculation completed")
line2_11 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,Random_list_value)#[::-1]kshell
print("92%---Pagerank Collapse rate calculation completed")


########################################################################################
print("  3_4.Calculate the collapse rate of the network ___ residual subnet sensitive rate----------------------------------------------")
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
line3_1 = kill_nodes_Susceptibility_value(G1,list_kpd[::-1])#[::-1]KPD
print("10%---KPD Collapse rate calculation completed")
line3_2 = kill_nodes_Susceptibility_value(G1,list_kpdn[::-1])#[::-1]kshell
print("20%---KPDN Collapse rate calculation completed")
line3_3 = kill_nodes_Susceptibility_value(G1,D_list_value[::-1])#[::-1]kshell
print("30%---degree Collapse rate calculation completed")
line3_4 =kill_nodes_Susceptibility_value(G1,Kshell_list_value[::-1])#[::-1]kshell
print("40%---Kshell Collapse rate calculation completed")
# line2_5 = kill_nodes_Find_Sub_Graph_edges_efficiency(G1,CC_list_value[::-1])#[::-1]kshell
# print("50%---CC 崩坏率计算完成")
line3_6 = kill_nodes_Susceptibility_value(G1,DWT_list_value)#[::-1]kshell
print("60%---DWT Collapse rate calculation completed")
line3_7 = kill_nodes_Susceptibility_value(G1,CI_list_value[::-1])#[::-1]kshell
print("70%---CI Collapse rate calculation completed")
line3_8 = kill_nodes_Susceptibility_value(G1,WL_list_value[::-1])#[::-1]kshell
print("80%---WL Collapse rate calculation completed")
line3_9 = kill_nodes_Susceptibility_value(G1,INCC_list_value[::-1])#[::-1]kshell
print("90%---INCC Collapse rate calculation completed")
line3_10 = kill_nodes_Susceptibility_value(G1,PR_list_value[::-1])#[::-1]kshell
print("91%---Pagerank Collapse rate calculation completed")
line3_11 = kill_nodes_Susceptibility_value(G1,Random_list_value)#[::-1]kshell
print("92%---Pagerank Collapse rate calculation completed")
#############################################




# DWT3_list_value
# line7 = kill_nodes_Find_max_Sub_Graph(G1,MoveMethod_list_value[::-1])
# Get_Move_Methods(G1)
# print('返回 KPDN 的 子图崩溃率 = ', largest_kpdn)
print("=================================================================")
# 打印网络基本信息
print("------Name：", title_G1)
print("------Number of nodes:", len_nodes)
print("------Edges of nodes:", len_edges)
print("------Average degree:", len_edges/len_nodes)
print("------Network density:", len_edges/(len_nodes-1)/len_nodes)
# print("网络直径:", max_diameter)
print("---Average clustering coefficient：", avg_clustering)
print("=================================================================")
print("5.generating image  -----------------------------------------------")
print("   5.1 Start generating connectivity coefficient image  ------------------------------------------")
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
# x = list(largest_kpd.keys())
x2 = list(line2.keys())
y1 = list(line1.values())
y2 = list(line2.values())
y3 = list(line3.values())
y4 = list(line4.values())
# y5 = list(line5.values())
y6 = list(line6.values())
x7 = list(line7.keys())
y7 = list(line7.values())
y8 = list(line8.values())
y9 = list(line9.values())
y10 = list(line10.values())
y11 = list(line11.values())
print("=================================================================")
print("Output the sorting of nodes in 1% intervals sequentially, ranging from 0% to 20% (that is, 0%, 1%, 2%, 3%, ..., 10%).")
print("1%  from 0% to 10%-----------------------------------------------")
print('x2 = ',x2[0],x2[1],x2[2],x2[3],x2[4],x2[5],x2[6],x2[7],x2[8],x2[9],x2[10])
print('y1 = ',y1[0],y1[1],y1[2],y1[3],y1[4],y1[5],y1[6],y1[7],y1[8],y1[9],y1[10])
print('y2 = ',y2[0],y2[1],y2[2],y2[3],y2[4],y2[5],y2[6],y2[7],y2[8],y2[9],y2[10])
print('y3 = ',y3[0],y3[1],y3[2],y3[3],y3[4],y3[5],y3[6],y3[7],y3[8],y3[9],y3[10])
print('y4 = ',y4[0],y4[1],y4[2],y4[3],y4[4],y4[5],y4[6],y4[7],y4[8],y4[9],y4[10])
# print('y5 = ',y5)
print('y6 = ',y6[0],y6[1],y6[2],y6[3],y6[4],y6[5],y6[6],y6[7],y6[8],y6[9],y6[10])
print('y7 = ',y7[0],y7[1],y7[2],y7[3],y7[4],y7[5],y7[6],y7[7],y7[8],y7[9],y7[10])
print('y8 = ',y8[0],y8[1],y8[2],y8[3],y8[4],y8[5],y8[6],y8[7],y8[8],y8[9],y8[10])
print('y9 = ',y9[0],y9[1],y9[2],y9[3],y9[4],y9[5],y9[6],y9[7],y9[8],y9[9],y9[10])
print('y10 = ',y10[0],y10[1],y10[2],y10[3],y10[4],y10[5],y10[6],y10[7],y10[8],y10[9],y10[10])
print('y11 = ',y11[0],y11[1],y11[2],y11[3],y11[4],y11[5],y11[6],y11[7],y11[8],y11[9],y11[10])
print("=================================================================")
print("Output the sorting of nodes in 2% intervals sequentially, ranging from 0% to 20% (that is, 0%, 2%, 4%, 6%, ..., 20%).")
print("2%  from 0% to 20%-----------------------------------------------")
t = 2###*t
print('x2 = ',x2[0],x2[2],x2[4],x2[6],x2[8],x2[10],x2[12],x2[14],x2[16],x2[18],x2[20])
print('y1 = ',y1[0],y1[1*t],y1[2*t],y1[3*t],y1[4*t],y1[5*t],y1[6*t],y1[7*t],y1[8*t],y1[9*t],y1[10*t])
print('y2 = ',y2[0],y2[1*t],y2[2*t],y2[3*t],y2[4*t],y2[5*t],y2[6*t],y2[7*t],y2[8*t],y2[9*t],y2[10*t])
print('y3 = ',y3[0],y3[1*t],y3[2*t],y3[3*t],y3[4*t],y3[5*t],y3[6*t],y3[7*t],y3[8*t],y3[9*t],y3[10*t])
print('y4 = ',y4[0],y4[1*t],y4[2*t],y4[3*t],y4[4*t],y4[5*t],y4[6*t],y4[7*t],y4[8*t],y4[9*t],y4[10*t])
# print('y5 = ',y5)
print('y6 = ',y6[0],y6[1*t],y6[2*t],y6[3*t],y6[4*t],y6[5*t],y6[6*t],y6[7*t],y6[8*t],y6[9*t],y6[10*t])
print('y7 = ',y7[0],y7[1*t],y7[2*t],y7[3*t],y7[4*t],y7[5*t],y7[6*t],y7[7*t],y7[8*t],y7[9*t],y7[10*t])
print('y8 = ',y8[0],y8[1*t],y8[2*t],y8[3*t],y8[4*t],y8[5*t],y8[6*t],y8[7*t],y8[8*t],y8[9*t],y8[10*t])
print('y9 = ',y9[0],y9[1*t],y9[2*t],y9[3*t],y9[4*t],y9[5*t],y9[6*t],y9[7*t],y9[8*t],y9[9*t],y9[10*t])
print('y10 = ',y10[0],y10[1*t],y10[2*t],y10[3*t],y10[4*t],y10[5*t],y10[6*t],y10[7*t],y10[8*t],y10[9*t],y10[10*t])
print('y11 = ',y11[0],y11[1*t],y11[2*t],y11[3*t],y11[4*t],y11[5*t],y11[6*t],y11[7*t],y11[8*t],y11[9*t],y11[10*t])
print("=================================================================")
print("Output the sorting of nodes in 10% intervals sequentially, ranging from 0% to 100% (that is, 0%, 10%, 20%, 30%, ..., 100%).")
print("10%  from 0% to 100%-----------------------------------------------")
print('x2 = ',x2[0],x2[10],x2[20],x2[30],x2[40],x2[50],x2[60],x2[70],x2[80],x2[90],x2[99])
print('y1 = ',y1[0],y1[10],y1[20],y1[30],y1[40],y1[50],y1[60],y1[70],y1[80],y1[90],y1[99])
print('y2 = ',y2[0],y2[10],y2[20],y2[30],y2[40],y2[50],y2[60],y2[70],y2[80],y2[90],y2[99])
print('y3 = ',y3[0],y3[10],y3[20],y3[30],y3[40],y3[50],y3[60],y3[70],y3[80],y3[90],y3[99])
print('y4 = ',y4[0],y4[10],y4[20],y4[30],y4[40],y4[50],y4[60],y4[70],y4[80],y4[90],y4[99])
# print('y5 = ',y5)
print('y6 = ',y6[0],y6[10],y6[20],y6[30],y6[40],y6[50],y6[60],y6[70],y6[80],y6[90],y6[99])
print('y7 = ',y7[0],y7[10],y7[20],y7[30],y7[40],y7[50],y7[60],y7[70],y7[80],y7[90],y7[99])
print('y8 = ',y8[0],y8[10],y8[20],y8[30],y8[40],y8[50],y8[60],y8[70],y8[80],y8[90],y8[99])
print('y9 = ',y9[0],y9[10],y9[20],y9[30],y9[40],y9[50],y9[60],y9[70],y9[80],y9[90],y9[99])
print('y10 = ',y10[0],y10[10],y10[20],y10[30],y10[40],y10[50],y10[60],y10[70],y10[80],y10[90],y10[99])
print('y11 = ',y11[0],y11[10],y11[20],y11[30],y11[40],y11[50],y11[60],y11[70],y11[80],y11[90],y11[99])
# y12 = list(line12.values())
# # y13 = list(line13.values())
# y14 = list(line14.values())
# # y15 = list(line15.values())
# # y16 = list(line16.values())
# y17 = list(line17.values())
# y18 = list(line18.values())

print("   5.2 Start generating ___ edge residual rate ___ image data  ------------------------------------------")
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
# x = list(largest_kpd.keys())
x2_2 = list(line2_2.keys())
y2_1 = list(line2_1.values())
y2_2 = list(line2_2.values())
y2_3 = list(line2_3.values())
y2_4 = list(line2_4.values())
# y2_5 = list(line2_5.values())
y2_6 = list(line2_6.values())
y2_7 = list(line2_7.values())
y2_8 = list(line2_8.values())
y2_9 = list(line2_9.values())
y2_10 = list(line2_10.values())
y2_11 = list(line2_11.values())
# print('x2_2 = ',x2_2)
# print('y2_1 = ',y2_1)
# print('y2_2 = ',y2_2)
# print('y2_3 = ',y2_3)
# print('y2_4 = ',y2_4)
# # print('y2_5 = ',y2_5)
# print('y2_6 = ',y2_6)
# print('y2_7 = ',y2_7)
# print('y2_8 = ',y2_8)
# print('y2_9 = ',y2_9)
# print('y2_10 = ',y2_10)
# print('y2_11 = ',y2_11)
print("=================================================================")
print("Output the sorting of nodes in 1% intervals sequentially, ranging from 0% to 20% (that is, 0%, 1%, 2%, 3%, ..., 10%).")
print("1%  from 0% to 10%-----------------------------------------------")
print('x2_2 = ',x2_2[0],x2_2[1],x2_2[2],x2_2[3],x2_2[4],x2_2[5],x2_2[6],x2_2[7],x2_2[8],x2_2[9],x2_2[10])
print('y2_1 = ',y2_1[0],y2_1[1],y2_1[2],y2_1[3],y2_1[4],y2_1[5],y2_1[6],y2_1[7],y2_1[8],y2_1[9],y2_1[10])
print('y2_2 = ',y2_2[0],y2_2[1],y2_2[2],y2_2[3],y2_2[4],y2_2[5],y2_2[6],y2_2[7],y2_2[8],y2_2[9],y2_2[10])
print('y2_3 = ',y2_3[0],y2_3[1],y2_3[2],y2_3[3],y2_3[4],y2_3[5],y2_3[6],y2_3[7],y2_3[8],y2_3[9],y2_3[10])
print('y2_4 = ',y2_4[0],y2_4[1],y2_4[2],y2_4[3],y2_4[4],y2_4[5],y2_4[6],y2_4[7],y2_4[8],y2_4[9],y2_4[10])
# print('y5 = ',y5)
print('y2_6 = ',y2_6[0],y2_6[1],y2_6[2],y2_6[3],y2_6[4],y2_6[5],y2_6[6],y2_6[7],y2_6[8],y2_6[9],y2_6[10])
print('y2_7 = ',y2_7[0],y2_7[1],y2_7[2],y2_7[3],y2_7[4],y2_7[5],y2_7[6],y2_7[7],y2_7[8],y2_7[9],y2_7[10])
print('y2_8 = ',y2_8[0],y2_8[1],y2_8[2],y2_8[3],y2_8[4],y2_8[5],y2_8[6],y2_8[7],y2_8[8],y2_8[9],y2_8[10])
print('y2_9 = ',y2_9[0],y2_9[1],y2_9[2],y2_9[3],y2_9[4],y2_9[5],y2_9[6],y2_9[7],y2_9[8],y2_9[9],y2_9[10])
print('y2_10 = ',y2_10[0],y2_10[1],y2_10[2],y2_10[3],y2_10[4],y2_10[5],y2_10[6],y2_10[7],y2_10[8],y2_10[9],y2_10[10])
print('y2_11 = ',y2_11[0],y2_11[1],y2_11[2],y2_11[3],y2_11[4],y2_11[5],y2_11[6],y2_11[7],y2_11[8],y2_11[9],y2_11[10])
print("=================================================================")
print("Output the sorting of nodes in 2% intervals sequentially, ranging from 0% to 20% (that is, 0%, 2%, 4%, 6%, ..., 20%).")
print("2%  from 0% to 20%-----------------------------------------------")
t = 2###*t
print('x2 = ',x2_2[0],x2_2[2],x2_2[4],x2_2[6],x2_2[8],x2_2[10],x2_2[12],x2_2[14],x2_2[16],x2_2[18],x2_2[20])
print('y1 = ',y2_1[0],y2_1[1*t],y2_1[2*t],y2_1[3*t],y2_1[4*t],y2_1[5*t],y2_1[6*t],y2_1[7*t],y2_1[8*t],y2_1[9*t],y2_1[10*t])
print('y2 = ',y2_2[0],y2_2[1*t],y2_2[2*t],y2_2[3*t],y2_2[4*t],y2_2[5*t],y2_2[6*t],y2_2[7*t],y2_2[8*t],y2_2[9*t],y2_2[10*t])
print('y3 = ',y2_3[0],y2_3[1*t],y2_3[2*t],y2_3[3*t],y2_3[4*t],y2_3[5*t],y2_3[6*t],y2_3[7*t],y2_3[8*t],y2_3[9*t],y2_3[10*t])
print('y4 = ',y2_4[0],y2_4[1*t],y2_4[2*t],y2_4[3*t],y2_4[4*t],y2_4[5*t],y2_4[6*t],y2_4[7*t],y2_4[8*t],y2_4[9*t],y2_4[10*t])
# print('y5 = ',y5)
print('y6 = ',y2_6[0],y2_6[1*t],y2_6[2*t],y2_6[3*t],y2_6[4*t],y2_6[5*t],y2_6[6*t],y2_6[7*t],y2_6[8*t],y2_6[9*t],y2_6[10*t])
print('y7 = ',y2_7[0],y2_7[1*t],y2_7[2*t],y2_7[3*t],y2_7[4*t],y2_7[5*t],y2_7[6*t],y2_7[7*t],y2_7[8*t],y2_7[9*t],y2_7[10*t])
print('y8 = ',y2_8[0],y2_8[1*t],y2_8[2*t],y2_8[3*t],y2_8[4*t],y2_8[5*t],y2_8[6*t],y2_8[7*t],y2_8[8*t],y2_8[9*t],y2_8[10*t])
print('y9 = ',y2_9[0],y2_9[1*t],y2_9[2*t],y2_9[3*t],y2_9[4*t],y2_9[5*t],y2_9[6*t],y2_9[7*t],y2_9[8*t],y2_9[9*t],y2_9[10*t])
print('y10 = ',y2_10[0],y2_10[1*t],y2_10[2*t],y2_10[3*t],y2_10[4*t],y2_10[5*t],y2_10[6*t],y2_10[7*t],y2_10[8*t],y2_10[9*t],y2_10[10*t])
print('y11 = ',y2_11[0],y2_11[1*t],y2_11[2*t],y2_11[3*t],y2_11[4*t],y2_11[5*t],y2_11[6*t],y2_11[7*t],y2_11[8*t],y2_11[9*t],y2_11[10*t])
print("=================================================================")
print("Output the sorting of nodes in 10% intervals sequentially, ranging from 0% to 100% (that is, 0%, 10%, 20%, 30%, ..., 100%).")
print("10%  from 0% to 100%-----------------------------------------------")
print('x2_2 = ',x2_2[0],x2_2[10],x2_2[20],x2_2[30],x2_2[40],x2_2[50],x2_2[60],x2_2[70],x2_2[80],x2_2[90],x2_2[99])
print('y2_1 = ',y2_1[0],y2_1[10],y2_1[20],y2_1[30],y2_1[40],y2_1[50],y2_1[60],y2_1[70],y2_1[80],y2_1[90],y2_1[99])
print('y2_2 = ',y2_2[0],y2_2[10],y2_2[20],y2_2[30],y2_2[40],y2_2[50],y2_2[60],y2_2[70],y2_2[80],y2_2[90],y2_2[99])
print('y2_3 = ',y2_3[0],y2_3[10],y2_3[20],y2_3[30],y2_3[40],y2_3[50],y2_3[60],y2_3[70],y2_3[80],y2_3[90],y2_3[99])
print('y2_4 = ',y2_4[0],y2_4[10],y2_4[20],y2_4[30],y2_4[40],y2_4[50],y2_4[60],y2_4[70],y2_4[80],y2_4[90],y2_4[99])
# print('y5 = ',y5)
print('y2_6 = ',y2_6[0],y2_6[10],y2_6[20],y2_6[30],y2_6[40],y2_6[50],y2_6[60],y2_6[70],y2_6[80],y2_6[90],y2_6[99])
print('y2_7 = ',y2_7[0],y2_7[10],y2_7[20],y2_7[30],y2_7[40],y2_7[50],y2_7[60],y2_7[70],y2_7[80],y2_7[90],y2_7[99])
print('y2_8 = ',y2_8[0],y2_8[10],y2_8[20],y2_8[30],y2_8[40],y2_8[50],y2_8[60],y2_8[70],y2_8[80],y2_8[90],y2_8[99])
print('y2_9 = ',y2_9[0],y2_9[10],y2_9[20],y2_9[30],y2_9[40],y2_9[50],y2_9[60],y2_9[70],y2_9[80],y2_9[90],y2_9[99])
print('y2_10 = ',y2_10[0],y2_10[10],y2_10[20],y2_10[30],y2_10[40],y2_10[50],y2_10[60],y2_10[70],y2_10[80],y2_10[90],y2_10[99])
print('y2_11 = ',y2_11[0],y2_11[10],y2_11[20],y2_11[30],y2_11[40],y2_11[50],y2_11[60],y2_11[70],y2_11[80],y2_11[90],y2_11[99])


print("=================================================================")
print("   5.3 Start generating ____ subnet connectivity efficiency ____ image data  ------------------------------------------")
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
x3_2 = list(line3_2.keys())
y3_1 = list(line3_1.values())
y3_2 = list(line3_2.values())
y3_3 = list(line3_3.values())
y3_4 = list(line3_4.values())
# y3_5 = list(line3_5.values())
y3_6 = list(line3_6.values())
y3_7 = list(line3_7.values())
y3_8 = list(line3_8.values())
y3_9 = list(line3_9.values())
y3_10 = list(line3_10.values())
y3_11 = list(line3_11.values())
# print('x3_2 = ',x3_2)
# print('y3_1 = ',y3_1)
# print('y3_2 = ',y3_2)
# print('y3_3 = ',y3_3)
# print('y3_4 = ',y3_4)
# # print('y3_5 = ',y3_5)
# print('y3_6 = ',y3_6)
# print('y3_7 = ',y3_7)
# print('y3_8 = ',y3_8)
# print('y3_9 = ',y3_9)
# print('y3_10 = ',y3_10)
# print('y3_11 = ',y3_11)
max_key3_1 = max(line3_1, key=line3_1.get)
max_key3_2 = max(line3_2, key=line3_2.get)
max_key3_3 = max(line3_3, key=line3_3.get)
max_key3_4 = max(line3_4, key=line3_4.get)
max_key3_6 = max(line3_6, key=line3_6.get)
max_key3_7 = max(line3_7, key=line3_7.get)
max_key3_8 = max(line3_8, key=line3_8.get)
max_key3_9 = max(line3_9, key=line3_9.get)
max_key3_10 = max(line3_10, key=line3_10.get)
max_key3_11 = max(line3_11, key=line3_11.get)
# print('max_key3_1',max_key3_1,)
print("=================================================================")
print("The abscissa of the maximum point of the sensitivity characteristic curve")
print("# 1kpd  2kpdn  3degree  4kshell  5DWT  6CI  7WL  8INCC  9Pagerank  10random")
print(max_key3_1,max_key3_2,max_key3_3,max_key3_4,max_key3_6,max_key3_7,max_key3_8,max_key3_9,max_key3_10,max_key3_11)

print('x3_2 = ',x3_2[0],x3_2[10],x3_2[20],x3_2[30],x3_2[40],x3_2[50],x3_2[60],x3_2[70],x3_2[80],x3_2[90],x3_2[99])
print('y3_1 = ',y3_1[0],y3_1[10],y3_1[20],y3_1[30],y3_1[40],y3_1[50],y3_1[60],y3_1[70],y3_1[80],y3_1[90],y3_1[99])
print('y3_2 = ',y3_2[0],y3_2[10],y3_2[20],y3_2[30],y3_2[40],y3_2[50],y3_2[60],y3_2[70],y3_2[80],y3_2[90],y3_2[99])
print('y3_3 = ',y3_3[0],y3_3[10],y3_3[20],y3_3[30],y3_3[40],y3_3[50],y3_3[60],y3_3[70],y3_3[80],y3_3[90],y3_3[99])
print('y3_4 = ',y3_4[0],y3_4[10],y3_4[20],y3_4[30],y3_4[40],y3_4[50],y3_4[60],y3_4[70],y3_4[80],y3_4[90],y3_4[99])
# print('y5 = ',y5)
print('y3_6 = ',y3_6[0],y3_6[10],y3_6[20],y3_6[30],y3_6[40],y3_6[50],y3_6[60],y3_6[70],y3_6[80],y3_6[90],y3_6[99])
print('y3_7 = ',y3_7[0],y3_7[10],y3_7[20],y3_7[30],y3_7[40],y3_7[50],y3_7[60],y3_7[70],y3_7[80],y3_7[90],y3_7[99])
print('y3_8 = ',y3_8[0],y3_8[10],y3_8[20],y3_8[30],y3_8[40],y3_8[50],y3_8[60],y3_8[70],y3_8[80],y3_8[90],y3_8[99])
print('y3_9 = ',y3_9[0],y3_9[10],y3_9[20],y3_9[30],y3_9[40],y3_9[50],y3_9[60],y3_9[70],y3_9[80],y3_9[90],y3_9[99])
print('y3_10 = ',y3_10[0],y3_10[10],y3_10[20],y3_10[30],y3_10[40],y3_10[50],y3_10[60],y3_10[70],y3_10[80],y3_10[90],y3_10[99])
print('y3_11 = ',y3_11[0],y3_11[10],y3_11[20],y3_11[30],y3_11[40],y3_11[50],y3_11[60],y3_11[70],y3_11[80],y3_11[90],y3_11[99])
# y7 = MoveMethod_list_value[::-1]
# print("6.展示 图像  -----------------------------------------------")
# plt.plot(x, y0,label='kpd',marker = 'h',markersize = 5.5)
# plt.plot(x, y1,label='kpdn',marker = 'D',markersize = 5)
# plt.plot(x, y2,label='DC',marker = 'o',markersize = 5)
# plt.plot(x, y3,label='kshell',marker = '*',markersize = 5.5)#,color='#6ba353'
# # plt.scatter(x, y3,label='kshell',marker = '+',s = 5)
# plt.plot(x, y4,label='CC',marker = '>',markersize = 4.5)
# plt.plot(x, y5,label='BC',marker = '<',markersize = 4.5)
# # plt.plot(x, y6,label='DWT')
# # plt.plot(x7, y7,label='Dyn_KPD')
# # plt.plot(x7, y8,label='Dyn_DC')
# # plt.plot(x, y9,label='DWT2')
# plt.plot(x, y10,label='DWT',marker = '^',markersize = 4.5)
# plt.plot(x, y11,label='CI',marker = 'v',markersize = 4.5)
# plt.plot(x, y12,label='WL',marker = 'p',markersize = 4.5)
# plt.plot(x, y13,label='HL',marker = 'x',markersize = 4.5)
# plt.plot(x, y14,label='Rand',marker = '+',markersize = 4.5,color='#749551')
print("=================================================================")
print("6.Display different result images  -----------------------------------------------")
print("   6.1 Display connectivity coefficient image  -----------------------------------------------")
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
plt.plot(x2, y3,label='DC',marker = 'o',markersize = 4,color='#638b27')#6cba7d
plt.plot(x2, y7,label='CI',marker = 'v',markersize = 3.5,color='#5e9b8a')#'#cde5d2'
# plt.plot(x, y5,label='BC',marker = '<',markersize = 3.5,color='#42b395')#'#e9e29c'
plt.plot(x2, y1,label='kpd',marker = 'h',markersize = 4,color='#feb24c')
plt.plot(x2, y2,label='kpdn',marker = 'D',markersize = 3.5,color='#fc4e2a')
plt.plot(x2, y8,label='WL',marker = 'p',markersize = 3.5,color='#40ad5a')
plt.plot(x2, y4,label='kshell',marker = '*',markersize = 4.5,color='#228b3b')#,color='#6ba353'
plt.plot(x2, y6,label='DWT',marker = '^',markersize = 3.5,color='#8ab8fe')#9ec9e2
# plt.plot(x, y13,label='HC',marker = 'x',markersize = 3.5,color='#3c93c2')
# plt.plot(x, y4,label='CC',marker = '>',markersize = 3.5,color='#226e9c')
plt.plot(x2, y9,label='INCC',marker = '+',markersize = 3.5,color='#A91e2a')
# plt.plot(x, y15,label='SG',marker = '+',markersize = 3.5,color='#701c2c')
# plt.plot(x, y16,label='KPDNCC',marker = '+',markersize = 3.5,color='#401829')
plt.plot(x2, y10,label='Pagerank',marker = '+',markersize = 3.5,color='#401829')
plt.plot(x2, y11,label='Rand',marker = '+',markersize = 3.5,color='#0d4a70')


# print("6.展示 图像  -----------------------------------------------")
# plt.plot(x, y2,label='DC',marker = 'o',markersize = 5,color='#0d4a70')
# plt.plot(x, y10,label='DWT',marker = '^',markersize = 4.5,color='#226e9c')
# plt.plot(x, y5,label='BC',marker = '<',markersize = 4.5,color='#3c93c2')
# plt.plot(x, y11,label='CI',marker = 'v',markersize = 4.5,color='#228b3b')
# plt.plot(x, y0,label='kpd',marker = 'h',markersize = 5.5,color='#feb24c')
# plt.plot(x, y1,label='kpdn',marker = 'D',markersize = 5,color='#fc4e2a')
# plt.plot(x, y12,label='WL',marker = 'p',markersize = 4.5,color='#9ccea7')
# plt.plot(x, y3,label='kshell',marker = '*',markersize = 5.5,color='#40ad5a')#,color='#6ba353'
# plt.plot(x, y13,label='HL',marker = 'x',markersize = 4.5,color='#c5e1ef')
# plt.plot(x, y4,label='CC',marker = '>',markersize = 4.5,color='#b7e6a5')
#
# plt.plot(x, y14,label='Rand',marker = '+',markersize = 4.5,color='#e4f1f7')

# '#0d4a70' '#226e9c' '#3c93c2' '#228b3b' '#40ad5a' '9ccea7' 'c5e1ef' 'b7e6a5' 'e4f1f7'


# plt.scatter(x,y)
plt.title(title_G1)
plt.savefig('quite__'+title_G1+'_Subnet',dpi = 300)# 保存图表
plt.legend()
plt.show()

print("   6.2 Display edge residual rate image   -----------------------------------------------")
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
plt.plot(x2_2, y2_3,label='DC',marker = 'o',markersize = 4,color='#638b27')#6cba7d
plt.plot(x2_2, y2_7,label='CI',marker = 'v',markersize = 3.5,color='#5e9b8a')#'#cde5d2'
# plt.plot(x, y5,label='BC',marker = '<',markersize = 3.5,color='#42b395')#'#e9e29c'
plt.plot(x2_2, y2_1,label='kpd',marker = 'h',markersize = 4,color='#feb24c')
plt.plot(x2_2, y2_2,label='kpdn',marker = 'D',markersize = 3.5,color='#fc4e2a')
plt.plot(x2_2, y2_8,label='WL',marker = 'p',markersize = 3.5,color='#40ad5a')
plt.plot(x2_2, y2_4,label='kshell',marker = '*',markersize = 4.5,color='#228b3b')#,color='#6ba353'
plt.plot(x2_2, y2_6,label='DWT',marker = '^',markersize = 3.5,color='#8ab8fe')#9ec9e2
# plt.plot(x, y13,label='HC',marker = 'x',markersize = 3.5,color='#3c93c2')
# plt.plot(x, y4,label='CC',marker = '>',markersize = 3.5,color='#226e9c')
plt.plot(x2_2, y2_9,label='INCC',marker = '+',markersize = 3.5,color='#A91e2a')
# plt.plot(x, y15,label='SG',marker = '+',markersize = 3.5,color='#701c2c')
# plt.plot(x, y16,label='KPDNCC',marker = '+',markersize = 3.5,color='#401829')
plt.plot(x2_2, y2_10,label='Pagerank',marker = '+',markersize = 3.5,color='#401829')
plt.plot(x2_2, y2_11,label='Rand',marker = '+',markersize = 3.5,color='#0d4a70')

# plt.scatter(x,y)
plt.title(title_G1+'_edges')
plt.savefig('quite__'+title_G1+'_edges',dpi = 300)# 保存图表
plt.legend()
plt.show()

print("   6.3 Display subnet sensitivity （展示 子网敏感性）  -----------------------------------------------")
### 1kpd  2kpdn  3degree  4kshell  5cc  6DWT  7CI  8WL  9INCC  10Pagerank  11random
plt.plot(x3_2, y3_3,label='DC',marker = 'o',markersize = 4,color='#638b27')#6cba7d
plt.plot(x3_2, y3_7,label='CI',marker = 'v',markersize = 3.5,color='#5e9b8a')#'#cde5d2'
# plt.plot(x, y5,label='BC',marker = '<',markersize = 3.5,color='#42b395')#'#e9e29c'
plt.plot(x3_2, y3_1,label='kpd',marker = 'h',markersize = 4,color='#feb24c')
plt.plot(x3_2, y3_2,label='kpdn',marker = 'D',markersize = 3.5,color='#fc4e2a')
plt.plot(x3_2, y3_8,label='WL',marker = 'p',markersize = 3.5,color='#40ad5a')
plt.plot(x3_2, y3_4,label='kshell',marker = '*',markersize = 4.5,color='#228b3b')#,color='#6ba353'
plt.plot(x3_2, y3_6,label='DWT',marker = '^',markersize = 3.5,color='#8ab8fe')#9ec9e2
# plt.plot(x, y13,label='HC',marker = 'x',markersize = 3.5,color='#3c93c2')
# plt.plot(x, y4,label='CC',marker = '>',markersize = 3.5,color='#226e9c')
plt.plot(x3_2, y3_9,label='INCC',marker = '+',markersize = 3.5,color='#A91e2a')
# plt.plot(x, y15,label='SG',marker = '+',markersize = 3.5,color='#701c2c')
# plt.plot(x, y16,label='KPDNCC',marker = '+',markersize = 3.5,color='#401829')
plt.plot(x3_2, y3_10,label='Pagerank',marker = '+',markersize = 3.5,color='#401829')
plt.plot(x3_2, y3_11,label='Rand',marker = '+',markersize = 3.5,color='#0d4a70')

# plt.scatter(x,y)
plt.title(title_G1+'susceptibility')
plt.savefig('quite__'+title_G1+'_Subnet',dpi = 300)# 保存图表
plt.legend()
plt.show()
print("7. The task is completed！  ------------------------------------------")
